# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Defined types

* [`wls_config::resourceadapter`](#wls_configresourceadapter)

### Resource types

* [`wls_authentication_provider`](#wls_authentication_provider): This resource allows you to manage authentication providers in a WebLogic domain.  Here is an example on how you should use this:      wls_au
* [`wls_cluster`](#wls_cluster): Allows you to manage a WebLogic cluster in a WebLogic domain.  Here is an example on how you should use this:      wls_cluster { 'WlsCluster'
* [`wls_coherence_cluster`](#wls_coherence_cluster): This resource allows you to manage a coherence cluster in a WebLogic domain.  Here is an example on how you should use this:      wls_coheren
* [`wls_coherence_server`](#wls_coherence_server): This resource allows you to manage a coherence server in an WebLogic domain.  Here is an example on how you should use this:      wls_coheren
* [`wls_datasource`](#wls_datasource): This resource allows you to manage a datasource in an WebLogic domain.  Here is an example on how you should use this:      # this will use d
* [`wls_default_role_mapper`](#wls_default_role_mapper): This resource allows you to manage Role Mappers in weblogic.
* [`wls_deployment`](#wls_deployment): This resource allows you to manage a cluster in an WebLogic domain.  Here is an example on how you should use this:      # 'jersey-bundle' wi
* [`wls_domain`](#wls_domain): This resource allows you to manage domain options.  This resource allows you to make changes to the existing WebLogic domain. You cannot crea
* [`wls_domain_partition`](#wls_domain_partition): This resource allows you to manage domain partitions in an WebLogic 12.2.1 domain.
* [`wls_domain_partition_resource_group`](#wls_domain_partition_resource_group): This resource allows you to manage resource group in an WebLogic 12.2.1 domain.
* [`wls_domain_partition_resource_group_deployment`](#wls_domain_partition_resource_group_deployment): This resource allows you to manage deployments in a resource group of a domain partition in an WebLogic 12.2.1 domain.
* [`wls_dynamic_cluster`](#wls_dynamic_cluster): This resource allows you to manage a dynamic cluster in an WebLogic domain.  Here is an example on how you should use this:      wls_dynamic_
* [`wls_exec`](#wls_exec): This resource allows you to execute a wlst command or script in the context.  This is a fallback resource. This means you should use it with 
* [`wls_file_persistence_store`](#wls_file_persistence_store): This resource allows you to manage a file persistence stores in an WebLogic domain.  Here is an example on how to use the `wls_file_persisten
* [`wls_foreign_jndi_provider`](#wls_foreign_jndi_provider): This resource allows you to manage a foreign jndi provider in an WebLogic domain.  Here is an example on how you should use this:      wls_fo
* [`wls_foreign_jndi_provider_link`](#wls_foreign_jndi_provider_link): This resource allows you to manage a datasource in an WebLogic domain.  Here is an example on how you should use this:      wls_foreign_jndi_
* [`wls_foreign_server`](#wls_foreign_server): This resource allows you to manage foreign servers in a JMS Module of a WebLogic domain.  Here is an example on how you should use this:     
* [`wls_foreign_server_object`](#wls_foreign_server_object): This resource allows you to manage a foreign server object in a JMS Module of a WebLogic domain.  Here is an example on how you should use th
* [`wls_group`](#wls_group): This resource allows you to manage group in a WebLogic Security Realm.  Here is an example on how you should use this:      wls_group { 'Supe
* [`wls_identity_asserter`](#wls_identity_asserter): This resource allows you to manage Identity Asserters in an WebLogic domain.  Here is an example on how you should use this:      wls_authent
* [`wls_jdbc_persistence_store`](#wls_jdbc_persistence_store): This resource allows you to manage a JDBC persistence stores in an WebLogic domain.  Here is an example on how you should use this:      wls_
* [`wls_jms_bridge_destination`](#wls_jms_bridge_destination): This resource allows you to manage a jms bridge destination in an WebLogic domain.  Here is an example on how you should use this:      wls_j
* [`wls_jms_connection_factory`](#wls_jms_connection_factory): This resource allows you to manage a connection factory in a JMS Module of a WebLogic domain.  Here is an example on how you should use this:
* [`wls_jms_module`](#wls_jms_module): This resource allows you to manage a JMS module in an WebLogic domain.  Here is an example on how you should use this:      wls_jms_module { 
* [`wls_jms_queue`](#wls_jms_queue): This resource allows you to manage a Queue in a JMS Module of a WebLogic domain.  Here is an example on how you should use this:      wls_jms
* [`wls_jms_quota`](#wls_jms_quota): This resource allows you to manage a Quota in a JMS module of a WebLogic domain.  Here is an example on how you should use this:      wls_jms
* [`wls_jms_security_policy`](#wls_jms_security_policy): This resource allows you to manage security authorization policies in an WebLogic Security Realm.
* [`wls_jms_sort_destination_key`](#wls_jms_sort_destination_key): This resource allows you to manage the sort destination key in a JMS module of a WebLogic domain.  Here is an example on how you should use t
* [`wls_jms_subdeployment`](#wls_jms_subdeployment): This resource allows you to manage a JMS subdeployment in a JMS module of a WebLogic domain.  Here is an example on how you should use this: 
* [`wls_jms_template`](#wls_jms_template): This resource allows you to manage a template in a JMS Module of a WebLogic domain.  Here is an example on how you should use this:      wls_
* [`wls_jms_topic`](#wls_jms_topic): This resource allows you to manage a Tpoic in a JMS Module of a WebLogic domain.  Here is an example on how you should use this:      wls_jms
* [`wls_jmsserver`](#wls_jmsserver): This resource allows you to manage a jmsserver in an WebLogic domain.  Here is an example on how you should use this:      wls_jmsserver { 'j
* [`wls_jndi_security_policy`](#wls_jndi_security_policy): This resource allows you to manage jndi security authorization policies in an WebLogic Security Realm.  Here is an example on how you should 
* [`wls_machine`](#wls_machine): This resource allows you to manage machine in an WebLogic domain.  Here is an example on how you should use this:      wls_machine { 'test2':
* [`wls_mail_session`](#wls_mail_session): This resource allows you to manage a mail_session in an WebLogic domain.  Here is an example on how you should use this:      wls_mail_sessio
* [`wls_managed_executor_service_template`](#wls_managed_executor_service_template): Weblogic Server provides a preconfigured, default ManagedExecutorService for each application, and applications can easily use it in web or E
* [`wls_managedserver`](#wls_managedserver): control a managed server or cluster state like running,stop,restart  Type for managed server control like start, running, abort and stop a ma
* [`wls_messaging_bridge`](#wls_messaging_bridge): This resource allows you to manage a messaging bridge in an WebLogic domain.  Here is an example on how you should use this:      wls_messagi
* [`wls_migratable_target`](#wls_migratable_target): This resource allows you to managed migratable targets in a WebLogic domain.  Here is an example on how you should use this:      wls_migrata
* [`wls_multi_datasource`](#wls_multi_datasource): This resource allows you to manage a multi datasource in an WebLogic domain.  Here is an example on how you should use this:      wls_multi_d
* [`wls_opatch`](#wls_opatch): This resource allows you to manage opatch patches on a specific middleware home.  wls_opatch {'/opt/oracle/middleware12c:16175470':   ensure 
* [`wls_path_service`](#wls_path_service): This resource allows you to manage path servers  Here is an example on how you should use this:      wls_path_service { 'jmy_service':       
* [`wls_rcu`](#wls_rcu): This is the Oracle WebLogic RCU ( Repository creation utility) installer type
* [`wls_resource_group_template`](#wls_resource_group_template): This resource allows you to manage resource group template in an WebLogic 12.2.1 domain.
* [`wls_resource_group_template_deployment`](#wls_resource_group_template_deployment): TThis resource allows you to manage deployments in a resource group template in an WebLogic 12.2.1 domain.
* [`wls_role`](#wls_role): This resource allows you to manage roles an WebLogic Secuirty Realm.
* [`wls_saf_error_handler`](#wls_saf_error_handler): This resource allows you to manage a SAF Error Handler in a JMS Module of a WebLogic domain.  Here is an example on how you should use this: 
* [`wls_saf_imported_destination`](#wls_saf_imported_destination): This resource allows you to manage a SAF imported destinations in a JMS Module of a WebLogic domain.  Here is an example on how you should us
* [`wls_saf_imported_destination_object`](#wls_saf_imported_destination_object): This resource allows you to manage a SAF imported destinations object in a JMS Module of a WebLogic domain.  Here is an example on how you sh
* [`wls_saf_remote_context`](#wls_saf_remote_context): This resource allows you to manage a SAF remote contexts in a JMS Module of a WebLogic domain.  Here is an example on how you should use this
* [`wls_safagent`](#wls_safagent): This resource allows you to manage a SAF agent in an WebLogic domain.  Here is an example on how you should use this:      wls_safagent { 'jm
* [`wls_security_policy`](#wls_security_policy): This resource allows you to manage security authorization policies in an WebLogic Security Realm.
* [`wls_security_realm`](#wls_security_realm): This resource allows you to manage an existing security realm.  Here is an example on how you can do this:     wls_security_realm { 'my_domai
* [`wls_server`](#wls_server): This resource allows you to manage server in an WebLogic domain.  Here is an example on how you should use this:      wls_server { 'wlsServer
* [`wls_server_channel`](#wls_server_channel): This resource allows you to manage a server channel in an WebLogic domain.  Here is an example on how you should use this:      wls_server_ch
* [`wls_server_template`](#wls_server_template): This resource allows you to manage server templates in an WebLogic domain.  Here is an example on how you should use this:      wls_server_te
* [`wls_server_tlog`](#wls_server_tlog): This resource allows you to manage server tlog in an WebLogic domain.  Here is an example on how you should use this:      wls_server_tlog { 
* [`wls_setting`](#wls_setting): This resource allows you to set the defaults for all other wls types.   All wls types needs a `wls_setting` definition. This is a pointer to 
* [`wls_singleton_service`](#wls_singleton_service): This resource allows you to managed singleton services in a WebLogic domain.  Here is an example on how you should use this:      wls_singlet
* [`wls_user`](#wls_user): This resource allows you to manage user in an WebLogic Security Realm.  Here is an example on how you should use this:      wls_user { 'Oracl
* [`wls_virtual_host`](#wls_virtual_host): This resource allows you to manage virtual host in an WebLogic domain.  Here is an example on how you should use this:      wls_virtual_host 
* [`wls_virtual_target`](#wls_virtual_target): This resource allows you to manage virtual targets in an WebLogic 12.2.1 domain.
* [`wls_workmanager`](#wls_workmanager): This resource allows you to manage workmanagers in an WebLogic domain.  Here is an example on how you should use this:      wls_workmanager {
* [`wls_workmanager_constraint`](#wls_workmanager_constraint): This resource allows you to manage work manager constraints in an WebLogic domain.  Here is an example on how you should use this:      wls_w

### Tasks

* [`start_managed_servers`](#start_managed_servers): Start all managed servers in a specified domain except the servers on the skip list
* [`stop_adminserver`](#stop_adminserver): Stop the admin server in a specified domain expect the Admin Server and the servers on the skip list
* [`stop_managed_servers`](#stop_managed_servers): Stop all managed servers in a specified domain except the Admin Server and the servers on the skip list

## Defined types

### <a name="wls_configresourceadapter"></a>`wls_config::resourceadapter`

The wls_config::resourceadapter class.

#### Parameters

The following parameters are available in the `wls_config::resourceadapter` defined type:

* [`middleware_home_dir`](#middleware_home_dir)
* [`weblogic_home_dir`](#weblogic_home_dir)
* [`jdk_home_dir`](#jdk_home_dir)
* [`wls_domains_dir`](#wls_domains_dir)
* [`domain_name`](#domain_name)
* [`adapter_name`](#adapter_name)
* [`adapter_path`](#adapter_path)
* [`adapter_plan_dir`](#adapter_plan_dir)
* [`adapter_plan`](#adapter_plan)
* [`adapter_entry`](#adapter_entry)
* [`adapter_entry_property`](#adapter_entry_property)
* [`adapter_entry_value`](#adapter_entry_value)
* [`adminserver_address`](#adminserver_address)
* [`adminserver_port`](#adminserver_port)
* [`userConfigFile`](#userConfigFile)
* [`userKeyFile`](#userKeyFile)
* [`weblogic_user`](#weblogic_user)
* [`weblogic_password`](#weblogic_password)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`download_dir`](#download_dir)
* [`log_output`](#log_output)

##### <a name="middleware_home_dir"></a>`middleware_home_dir`

Data type: `Any`



Default value: `hiera('wls_middleware_home_dir')`

##### <a name="weblogic_home_dir"></a>`weblogic_home_dir`

Data type: `Any`



Default value: `hiera('wls_weblogic_home_dir')`

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

Data type: `Any`



Default value: `hiera('wls_jdk_home_dir')`

##### <a name="wls_domains_dir"></a>`wls_domains_dir`

Data type: `Any`



Default value: `hiera('wls_domains_dir'           , undef)`

##### <a name="domain_name"></a>`domain_name`

Data type: `Any`



Default value: `hiera('domain_name'               , undef)`

##### <a name="adapter_name"></a>`adapter_name`

Data type: `Any`



Default value: ``undef``

##### <a name="adapter_path"></a>`adapter_path`

Data type: `Any`



Default value: ``undef``

##### <a name="adapter_plan_dir"></a>`adapter_plan_dir`

Data type: `Any`



Default value: ``undef``

##### <a name="adapter_plan"></a>`adapter_plan`

Data type: `Any`



Default value: ``undef``

##### <a name="adapter_entry"></a>`adapter_entry`

Data type: `Any`



Default value: ``undef``

##### <a name="adapter_entry_property"></a>`adapter_entry_property`

Data type: `Any`



Default value: ``undef``

##### <a name="adapter_entry_value"></a>`adapter_entry_value`

Data type: `Any`



Default value: ``undef``

##### <a name="adminserver_address"></a>`adminserver_address`

Data type: `Any`



Default value: `hiera('domain_adminserver_address', 'localhost')`

##### <a name="adminserver_port"></a>`adminserver_port`

Data type: `Any`



Default value: `hiera('domain_adminserver_port'   , 7001)`

##### <a name="userConfigFile"></a>`userConfigFile`

Data type: `Any`



Default value: `hiera('domain_user_config_file'   , undef)`

##### <a name="userKeyFile"></a>`userKeyFile`

Data type: `Any`



Default value: `hiera('domain_user_key_file'      , undef)`

##### <a name="weblogic_user"></a>`weblogic_user`

Data type: `Any`



Default value: `hiera('wls_weblogic_user'         , 'weblogic')`

##### <a name="weblogic_password"></a>`weblogic_password`

Data type: `Any`



Default value: `hiera('domain_wls_password'       , undef)`

##### <a name="os_user"></a>`os_user`

Data type: `Any`



Default value: `hiera('wls_os_user')`

##### <a name="os_group"></a>`os_group`

Data type: `Any`



Default value: `hiera('wls_os_group')`

##### <a name="download_dir"></a>`download_dir`

Data type: `Any`



Default value: `hiera('wls_download_dir')`

##### <a name="log_output"></a>`log_output`

Data type: `Any`



Default value: ``false``

## Resource types

### <a name="wls_authentication_provider"></a>`wls_authentication_provider`

This resource allows you to manage authentication providers in a WebLogic domain.

Here is an example on how you should use this:

    wls_authentication_provider { 'ldap':
      ensure            => 'present',
      control_flag      => 'SUFFICIENT',
      providerclassname => 'weblogic.security.providers.authentication.LDAPAuthenticator',
      attributes:       =>  'Principal;Host;Port;CacheTTL;CacheSize;MaxGroupMembershipSearchLevel;SSLEnabled',
      attributesvalues  =>  'ldapuser;ldapserver;389;60;1024;4;1',
      order             =>  '0'
    }

To manage Weblogic's DefaultIdentityAsserter use the wls_identity_asserter type. In this example
you are managing a provider in the default domain. When you want to
manage a provider in a specific domain, you can use:

    wls_authentication_provider { 'MyDomain/MyAuthenticationProvider':
      ensure           => 'present',
    }

Check [the Oracle Weblogic documentation](http://docs.oracle.com/middleware/1221/wls/INTRO/clustering.htm#INTRO185)
for more documentation about setting up and managing a WebLogic cluster.

#### Properties

The following properties are available in the `wls_authentication_provider` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_authentication_provider` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_authentication_provider` resource. You will seldom need to specify this ---
Puppet will usually discover the appropriate provider for your platform.

### <a name="wls_cluster"></a>`wls_cluster`

Allows you to manage a WebLogic cluster in a WebLogic domain.

Here is an example on how you should use this:

    wls_cluster { 'WlsCluster':
      ensure           => 'present',
      messagingmode    => 'unicast',
      migrationbasis   => 'consensus',
      servers          => ['wlsServer3','wlsServer4'],
      multicastaddress => '239.192.0.0',
      multicastport    => '7001',
    }

In this example you are managing a server in the default domain. When you want to
manage a cluster in a specific domain, you can use:

    wls_cluster { 'MuDomain/WlsCluster':
      ensure           => 'present',
      messagingmode    => 'unicast',
      migrationbasis   => 'consensus',
      servers          => ['wlsServer3','wlsServer4'],
      multicastaddress => '239.192.0.0',
      multicastport    => '7001',
    }

Check [the Oracle Weblogic documentation](http://docs.oracle.com/middleware/1221/wls/INTRO/clustering.htm#INTRO185)
for more documentation about setting up and managing a WebLogic cluster.

#### Properties

The following properties are available in the `wls_cluster` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_cluster` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_cluster` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_coherence_cluster"></a>`wls_coherence_cluster`

This resource allows you to manage a coherence cluster in a WebLogic domain.

Here is an example on how you should use this:

    wls_coherence_cluster { 'WebCoherenceCluster':
      ensure          => 'present',
      clusteringmode  => 'unicast',
      multicastport   => '33389',
      target          => ['WebCluster'],
      targettype      => ['Cluster'],
      unicastport     => '9999',
      storage_enabled =>  '1',
    }

In this example you are managing a cluster in the default domain. When you want to
manage a coherence cluster in a specific domain, you can use:

    wls_coherence_cluster { 'my_domain/defaultCoherenceCluster':
      ensure         => 'present',
      clusteringmode => 'unicast',
      multicastport  => '33387',
      unicastport    => '8888',
    }

Check [the Oracle Weblogic documentation](http://docs.oracle.com/middleware/1221/wls/INTRO/domains.htm#INTRO330)
for more documentation about setting up and managing a coherence cluster.

#### Properties

The following properties are available in the `wls_coherence_cluster` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_coherence_cluster` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_coherence_cluster` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="wls_coherence_server"></a>`wls_coherence_server`

This resource allows you to manage a coherence server in an WebLogic domain.

Here is an example on how you should use this:

    wls_coherence_server { 'default':
      ensure         => 'present',
      server         => 'LocalMachine',
      unicastaddress => 'localhost',
      unicastport    => '8888',
    }

In this example you are managing a server in the default domain. When you want to
manage a coherence server in a specific domain, you can use:

    wls_coherence_server { 'my_domain/default':
      ensure         => 'present',
      server         => 'LocalMachine',
      unicastaddress => 'localhost',
      unicastport    => '8888',
    }

Check [the Oracle Weblogic documentation](https://docs.oracle.com/middleware/1212/coherence/COHMG/toc.htm)
for more documentation about setting up and managing a coherence server.

#### Properties

The following properties are available in the `wls_coherence_server` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_coherence_server` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_coherence_server` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="wls_datasource"></a>`wls_datasource`

This resource allows you to manage a datasource in an WebLogic domain.

Here is an example on how you should use this:

    # this will use default as wls_setting identifier, no XA properties
    wls_datasource { 'hrDS':
      ensure                           => 'present',
      connectioncreationretryfrequency => '0',
      drivername                       => 'oracle.jdbc.xa.client.OracleXADataSource',
      extraproperties                  => ['SendStreamAsBlob=true', 'oracle.net.CONNECT_TIMEOUT=10001'],
      fanenabled                       => '0',
      globaltransactionsprotocol       => 'TwoPhaseCommit',
      initialcapacity                  => '2',
      initsql                          => 'None',
      jndinames                        => ['jdbc/hrDS', 'jdbc/hrDS2'],
      maxcapacity                      => '15',
      mincapacity                      => 1,
      rowprefetchenabled               => '0',
      rowprefetchsize                  => '48',
      secondstotrustidlepoolconnection => '10',
      statementcachesize               => '10',
      target                           => ['wlsServer1', 'wlsServer2'],
      targettype                       => ['Server', 'Server'],
      testconnectionsonreserve         => '0',
      testfrequency                    => '120',
      testtablename                    => 'SQL SELECT 1 FROM DUAL',
      url                              => 'jdbc:oracle:thin:@dbagent2.alfa.local:1521/test.oracle.com',
      user                             => 'hr',
      usexa                            => '0',
    }

In this example you are managing a datasource in the default domain. When you want to
manage a datasource in a specific domain, you can use:

    # this will use default as wls_setting identifier, no XA properties
    wls_datasource{'mydomain/hrDS':
      ...
      ensure                           => 'present',
      connectioncreationretryfrequency => '0',
      drivername                       => 'oracle.jdbc.xa.client.OracleXADataSource',
      ...
    }

Check the [WebLogic documentation](https://docs.oracle.com/middleware/1212/wls/INTRO/jdbc.htm#INTRO215) for more information
about configuring and managing datasources.

#### Properties

The following properties are available in the `wls_datasource` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_datasource` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_datasource` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_default_role_mapper"></a>`wls_default_role_mapper`

This resource allows you to manage Role Mappers in weblogic.

#### Properties

The following properties are available in the `wls_default_role_mapper` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_default_role_mapper` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_default_role_mapper` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="wls_deployment"></a>`wls_deployment`

This resource allows you to manage a cluster in an WebLogic domain.

Here is an example on how you should use this:

    # 'jersey-bundle' will use default as wls_setting identifier
    wls_deployment{'jersey-bundle':
      ensure            => 'present',
      deploymenttype    => 'Library',
      stagingmode       => 'nostage',
      remote            => "1",
      upload            => "1",
      target            => ['AdminServer', 'WebCluster'],
      targettype        => ['Server', 'Cluster'],
      versionidentifier => '1.18@1.18.0.0',
    }

In this example you are managing a deployment in the default domain. When you want to
manage a deployment in a specific domain, you can use:

    wls_deployment{'my_domain/webapp':
      ensure            => 'present',
      deploymenttype    => 'AppDeployment',
      stagingmode       => 'nostage',
      remote            => "1",
      upload            => "1",
      target            => ['WebCluster'],
      targettype        => ['Cluster'],
      versionidentifier => '1.1@1.1.0.0',
      require           => Wls_deployment['jersey-bundle']
    }

Check the [WebLogic documentation](https://docs.oracle.com/middleware/1212/wls/INTRO/deploying.htm#INTRO201) for more information
about application deployment.

#### Properties

The following properties are available in the `wls_deployment` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_deployment` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_deployment` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_domain"></a>`wls_domain`

This resource allows you to manage domain options.

This resource allows you to make changes to the existing WebLogic domain. You cannot
create a domain with this resource. If you want to create a domain, use `wls_install::domain`.
Here is an example on how you should use this:

    # In this case it will use default as wls_setting identifier
    wls_domain { 'Wls1036':
      ensure                                            => 'present',
      jmx_platform_mbean_server_enabled                 => 1,
      jmx_platform_mbean_server_used                    => 1,
      jpa_default_provider                              => 'org.eclipse.persistence.jpa.PersistenceProvider',
      jta_max_transactions                              => '20000',
      jta_transaction_timeout                           => '35',
      log_file_min_size                                 => '5000',
      log_filecount                                     => '10',
      log_filename                                      => '/var/log/weblogic/Wls1036.log',
      log_number_of_files_limited                       => 1,
      log_rotate_logon_startup                          => 1,
      log_rotationtype                                  => 'bySize',
      security_crossdomain                              => '0',
      web_app_container_show_archived_real_path_enabled => 1,
    }

In this example you are managing a domain in the default domain. When you want to
manage a domain in a specific domain, you can use:

    wls_domain { 'Wls11gSetting/Wls11g':
      ensure                                            => 'present',
      jmx_platform_mbean_server_enabled                 => '0',
      jmx_platform_mbean_server_used                    => 1,
      jpa_default_provider                              => 'org.apache.openjpa.persistence.PersistenceProviderImpl',
      jta_max_transactions                              => '10000',
      jta_transaction_timeout                           => '30',
      log_file_min_size                                 => '5000',
      log_filecount                                     => '5',
      log_filename                                      => '/var/log/weblogic/Wls11g.log',
      log_number_of_files_limited                       => '0',
      log_rotate_logon_startup                          => '0',
      log_rotationtype                                  => 'byTime',
      security_crossdomain                              => 1,
      web_app_container_show_archived_real_path_enabled => '0',
    }

#### Properties

The following properties are available in the `wls_domain` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_domain` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_domain` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

### <a name="wls_domain_partition"></a>`wls_domain_partition`

This resource allows you to manage domain partitions in an WebLogic 12.2.1 domain.

#### Properties

The following properties are available in the `wls_domain_partition` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_domain_partition` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_domain_partition` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="wls_domain_partition_resource_group"></a>`wls_domain_partition_resource_group`

This resource allows you to manage resource group in an WebLogic 12.2.1 domain.

#### Properties

The following properties are available in the `wls_domain_partition_resource_group` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_domain_partition_resource_group` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_domain_partition_resource_group` resource. You will seldom need to specify
this --- Puppet will usually discover the appropriate provider for your platform.

### <a name="wls_domain_partition_resource_group_deployment"></a>`wls_domain_partition_resource_group_deployment`

This resource allows you to manage deployments in a resource group of a domain partition in an WebLogic 12.2.1 domain.

#### Properties

The following properties are available in the `wls_domain_partition_resource_group_deployment` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_domain_partition_resource_group_deployment` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_domain_partition_resource_group_deployment` resource. You will seldom need to
specify this --- Puppet will usually discover the appropriate provider for your platform.

### <a name="wls_dynamic_cluster"></a>`wls_dynamic_cluster`

This resource allows you to manage a dynamic cluster in an WebLogic domain.

Here is an example on how you should use this:

    wls_dynamic_cluster{'DynamicCluster':
      ensure                 => 'present',
      calculated_listen_port => '0',  # '0' or '1'
      maximum_server_count   => '2',
      nodemanager_match      => 'Node1,Node2',
      server_name_prefix     => 'DynCluster-',
      server_template_name   => 'ServerTemplateWeb',
    }

In this example you are managing a dynamic cluster in the default domain. When you want to
manage a dynamic cluster in a specific domain, you can use:

    wls_dynamic_cluster{'my_domain/DynamicCluster':
      ensure                 => 'present',
      calculated_listen_port => '0',  # '0' or '1'
      maximum_server_count   => '2',
      nodemanager_match      => 'Node1,Node2',
      server_name_prefix     => 'DynCluster-',
      server_template_name   => 'ServerTemplateWeb',
    }

Check the [WebLogic documentation](https://docs.oracle.com/middleware/1212/wls/INTRO/clustering.htm#INTRO336) for more information
about configuring and managing datasources.

#### Properties

The following properties are available in the `wls_dynamic_cluster` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_dynamic_cluster` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_dynamic_cluster` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="wls_exec"></a>`wls_exec`

This resource allows you to execute a wlst command or script in the context.

This is a fallback resource. This means you should use it with care and only if there are no other Puppet types available.
Here is an example on how you can use this:

    wls_exec{'@/tmp/set_some_configuration.py':
      cwd         => '/tmp',
      refreshonly => true,
      logoutput   => true,
      unless      => '@/tmp/configuration_is_not_set.py',
    }

This statement will first execute the `/tmp/configuration_is_not_set.py` script. If this script returns
something, the main script (e.g. `/tmp/set_some_configuration.py`) will not be executed. If it returns nothing,
the `/tmp/set_some_configuration.py` script is executed.

Here is an example of a part of the unless script:

    if resource_available:
      print >>puppet, "true"

If the resource is available, you must write something to `puppet`. If the resource is not available,
do nothing.

**Formatting**

Because Python is sensitive for formatting, you should take care the formatting of the main and the
unless scripts. You **MUST** start both scripts at column 0.

You can also explicitly specify the domain:

    wls_exec{'my_domain/@/tmp/set_some_configuration.py':
      cwd         => '/tmp',
      refreshonly => true,
      logoutput   => true,
      unless      => '@/tmp/configuration_is_not_set.py',
    }

#### Parameters

The following parameters are available in the `wls_exec` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_exec` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

### <a name="wls_file_persistence_store"></a>`wls_file_persistence_store`

This resource allows you to manage a file persistence stores in an WebLogic domain.

Here is an example on how to use the `wls_file_persistence_store`:


    # this will use default as wls_setting identifier
    wls_file_persistence_store{'jmsFile1':
      ensure     => 'present',
      directory  => 'persistence1',
      target     => ['wlsServer1'],
      targettype => ['Server'],
    }

In this example you are managing a file persistence store in the default domain. When you want to
manage a file persistence store in a specific domain, you can use:

    wls_file_persistence_store{'mydomain/jmsFile2':
      ensure     => 'present',
      directory  => 'persistence2',
      target     => ['wlsServer2'],
      targettype => ['Server'],
    }

#### Properties

The following properties are available in the `wls_file_persistence_store` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_file_persistence_store` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_file_persistence_store` resource. You will seldom need to specify this ---
Puppet will usually discover the appropriate provider for your platform.

### <a name="wls_foreign_jndi_provider"></a>`wls_foreign_jndi_provider`

This resource allows you to manage a foreign jndi provider in an WebLogic domain.

Here is an example on how you should use this:

    wls_foreign_jndi_provider { 'DomainA':
      ensure                  => 'present',
      initial_context_factory => 'weblogic.jndi.WLInitialContextFactory',
      provider_properties     => ['bbb=aaaa', 'xxx=123'],
      provider_url            => 't3://10.10.10.100:7001',
      target                  => ['WebCluster'],
      targettype              => ['Cluster'],
      user                    => 'weblogic',
      password                => 'weblogic1',
    }

In this example you are managing a foreign jndi provider in the default domain. When you want to
manage a foreign jndi provider in a specific domain, you can use:


    wls_foreign_jndi_provider { 'my_domain/LDAP':
      ensure                  => 'present',
      initial_context_factory => 'com.sun.jndi.ldap.LdapCtxFactory',
      provider_properties     => ['referral=follow'],
      provider_url            => 'ldap://:10.10.10.100:389',
      target                  => ['AdminServer'],
      targettype              => ['Server'],
      user                    => 'cn=orcladmin',
      password                => 'weblogic1',
    }

#### Properties

The following properties are available in the `wls_foreign_jndi_provider` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_foreign_jndi_provider` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_foreign_jndi_provider` resource. You will seldom need to specify this ---
Puppet will usually discover the appropriate provider for your platform.

### <a name="wls_foreign_jndi_provider_link"></a>`wls_foreign_jndi_provider_link`

This resource allows you to manage a datasource in an WebLogic domain.

Here is an example on how you should use this:

    wls_foreign_jndi_provider_link { 'LDAP:aaaaa':
      ensure           => 'present',
      local_jndi_name  => 'aaaaa',
      remote_jndi_name => 'bbbbb',
    }

In this example you are managing a foreign jndi provider link in the default domain. When you want to
manage a foreign jndi provider link in a specific domain, you can use:

    wls_foreign_jndi_provider_link { 'my_domain/LDAP:ccccc':
      ensure           => 'present',
      local_jndi_name  => 'ccccc',
      remote_jndi_name => 'ddddd',
    }

#### Properties

The following properties are available in the `wls_foreign_jndi_provider_link` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_foreign_jndi_provider_link` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_foreign_jndi_provider_link` resource. You will seldom need to specify this ---
Puppet will usually discover the appropriate provider for your platform.

### <a name="wls_foreign_server"></a>`wls_foreign_server`

This resource allows you to manage foreign servers in a JMS Module of a WebLogic domain.

Here is an example on how you should use this:

    wls_foreign_server { 'jmsClusterModule:AQForeignServer':
      ensure                => 'present',
      defaulttargeting      => 1,
      extraproperties       => 'datasource=jdbc/hrDS',
      initialcontextfactory => ['oracle.jms.AQjmsInitialContextFactory'],
    }

In this example you are managing a foreign server in the default domain. When you want to
manage a foreign server in a specific domain, you can use:

    wls_foreign_server { 'my_domain/jmsClusterModule:Jboss':
      ensure                => 'present',
      connectionurl         => 'remote://10.10.10.10:4447',
      defaulttargeting      => '0',
      extraproperties       => ['java.naming.security.principal=jmsuser'],
      initialcontextfactory => 'org.jboss.naming.remote.client.InitialContextFactory',
      subdeployment         => 'wlsServers',
    }

#### Properties

The following properties are available in the `wls_foreign_server` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_foreign_server` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_foreign_server` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_foreign_server_object"></a>`wls_foreign_server_object`

This resource allows you to manage a foreign server object in a JMS Module of a WebLogic domain.

Here is an example on how you should use this:

    wls_foreign_server_object { 'jmsClusterModule:Jboss:CF':
      ensure         => 'present',
      localjndiname  => 'jms/jboss/CF',
      object_type    => 'connectionfactory',
      remotejndiname => 'jms/Remote/CF',
    }

In this example you are managing a foreign server object in the default domain. When you want to
manage a foreign server object in a specific domain, you can use:

wls_foreign_server_object { 'my_domain/jmsClusterModule:Jboss:JBossQ':
  ensure         => 'present',
  localjndiname  => 'jms/jboss/Queue',
  object_type    => 'destination',
  remotejndiname => 'jms/Remote/Queue',
}

#### Properties

The following properties are available in the `wls_foreign_server_object` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_foreign_server_object` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_foreign_server_object` resource. You will seldom need to specify this ---
Puppet will usually discover the appropriate provider for your platform.

### <a name="wls_group"></a>`wls_group`

This resource allows you to manage group in a WebLogic Security Realm.

Here is an example on how you should use this:

    wls_group { 'SuperUsers':
      ensure                 => 'present',
      authenticationprovider => 'DefaultAuthenticator',
      description            => 'SuperUsers',
      realm                  => 'myrealm',
      users                  => ['testuser2'],
    }

In this example you are managing a group in the default domain. When you want to
manage a group in a specific domain, you can use:

    wls_group { 'my_domain/TestGroup':
      ensure                 => 'present',
      authenticationprovider => 'DefaultAuthenticator',
      description            => 'TestGroup',
      realm                  => 'myrealm',
      users                  => ['testuser1','testuser2'],
    }

#### Properties

The following properties are available in the `wls_group` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_group` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_group` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

### <a name="wls_identity_asserter"></a>`wls_identity_asserter`

This resource allows you to manage Identity Asserters in an WebLogic domain.

Here is an example on how you should use this:

    wls_authentication_provider { 'DefaultIdentityAsserter':
      ensure            => 'present',
      providerclassname => 'weblogic.security.providers.authentication.DefaultIdentityAsserter',
      attributes:       => 'DigestReplayDetectionEnabled;UseDefaultUserNameMapper',
      attributesvalues  => '1;1;',
      activetypes       => 'AuthenticatedUser::X.509',
      defaultmappertype => 'CN',
    }


In this example you are managing a identity asserter in the default domain. When you want to
manage a identity asserter in a specific domain, you can use:

    wls_authentication_provider { 'my_domain/DefaultIdentityAsserter':
      ensure            => 'present',
      providerclassname => 'weblogic.security.providers.authentication.DefaultIdentityAsserter',
      attributes:       => 'DigestReplayDetectionEnabled;UseDefaultUserNameMapper',
      attributesvalues  => '1;1;',
      activetypes       => 'AuthenticatedUser::X.509',
      defaultmappertype => 'CN',
    }

#### Properties

The following properties are available in the `wls_identity_asserter` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_identity_asserter` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_identity_asserter` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="wls_jdbc_persistence_store"></a>`wls_jdbc_persistence_store`

This resource allows you to manage a JDBC persistence stores in an WebLogic domain.

Here is an example on how you should use this:

    wls_jdbc_persistence_store { 'JDBCStoreX':
      ensure      => 'present',
      datasource  => 'jmsDS',
      prefix_name => 'dev_',
      target      => ['wlsServer1'],
      targettype  => ['Server'],
    }

In this example you are managing a JDBC persistance store in the default domain. When you want to
manage a JDBC persistance store in a specific domain, you can use:

    wls_jdbc_persistence_store { 'my_domain/JDBCStoreX':
      ensure      => 'present',
      datasource  => 'jmsDS',
      prefix_name => 'dev_',
      target      => ['wlsServer1'],
      targettype  => ['Server'],
    }

#### Properties

The following properties are available in the `wls_jdbc_persistence_store` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_jdbc_persistence_store` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_jdbc_persistence_store` resource. You will seldom need to specify this ---
Puppet will usually discover the appropriate provider for your platform.

### <a name="wls_jms_bridge_destination"></a>`wls_jms_bridge_destination`

This resource allows you to manage a jms bridge destination in an WebLogic domain.

Here is an example on how you should use this:

    wls_jms_bridge_destination { 'myBridgeDest':
      ensure                => 'present',
      adapter               => 'eis.jms.WLSConnectionFactoryJNDINoTX',
      classpath             => 'myClasspath',
      connectionfactoryjndi => 'myCFJndi',
      connectionurl         => 'myConnUrl',
      destinationjndi       => 'myDestJndi',
      destinationtype       => 'Queue',
      initialcontextfactory => 'weblogic.jndi.WLInitialContextFactory',
    }

In this example you are managing a bridge destination in the default domain. When you want to
manage a bridge destination in a specific domain, you can use:

    wls_jms_bridge_destination { 'my_domain/myBridgeDest':
      ensure                => 'present',
      adapter               => 'eis.jms.WLSConnectionFactoryJNDINoTX',
      classpath             => 'myClasspath',
      connectionfactoryjndi => 'myCFJndi',
      connectionurl         => 'myConnUrl',
      destinationjndi       => 'myDestJndi',
      destinationtype       => 'Queue',
      initialcontextfactory => 'weblogic.jndi.WLInitialContextFactory',
    }

[Here](https://javamail.java.net/nonav/docs/api/) you can find more information about JMS bridge
desitinations.

#### Properties

The following properties are available in the `wls_jms_bridge_destination` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_jms_bridge_destination` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_jms_bridge_destination` resource. You will seldom need to specify this ---
Puppet will usually discover the appropriate provider for your platform.

### <a name="wls_jms_connection_factory"></a>`wls_jms_connection_factory`

This resource allows you to manage a connection factory in a JMS Module of a WebLogic domain.

Here is an example on how you should use this:

    wls_jms_connection_factory { 'jmsClusterModule:cf':
      ensure                    => 'present',
      attachjmsxuserid          => '0',
      clientidpolicy            => 'Restricted',
      defaulttargeting          => '0',
      jndiname                  => 'jms/cf',
      loadbalancingenabled      => 1,
      messagesmaximum           => '10',
      reconnectpolicy           => 'producer',
      serveraffinityenabled     => 1,
      subdeployment             => 'wlsServers',
      subscriptionsharingpolicy => 'Exclusive',
      transactiontimeout        => '3600',
      xaenabled                 => '0',
    }

In this example you are managing a connection factory in the default domain. When you want to
manage a connection factory in a specific domain, you can use:

    wls_jms_connection_factory { 'my_domain/jmsClusterModule:cf2':
      ensure                    => 'present',
      attachjmsxuserid          => '0',
      clientidpolicy            => 'Restricted',
      defaulttargeting          => 1,
      jndiname                  => 'jms/cf2',
      loadbalancingenabled      => 1,
      messagesmaximum           => '10',
      reconnectpolicy           => 'producer',
      serveraffinityenabled     => 1,
      subscriptionsharingpolicy => 'Exclusive',
      transactiontimeout        => '3600',
      xaenabled                 => 1,
    }

#### Properties

The following properties are available in the `wls_jms_connection_factory` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_jms_connection_factory` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_jms_connection_factory` resource. You will seldom need to specify this ---
Puppet will usually discover the appropriate provider for your platform.

### <a name="wls_jms_module"></a>`wls_jms_module`

This resource allows you to manage a JMS module in an WebLogic domain.

Here is an example on how you should use this:

    wls_jms_module { 'jmsClusterModule':
      ensure     => 'present',
      target     => ['WebCluster'],
      targettype => ['Cluster'],
    }

In this example you are managing a JMS module in the default domain. When you want to
manage a JMS module in a specific domain, you can use:

    wls_jms_module { 'my_domain/jmsClusterModule':
      ensure     => 'present',
      target     => ['WebCluster'],
      targettype => ['Cluster'],
    }

#### Properties

The following properties are available in the `wls_jms_module` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_jms_module` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_jms_module` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_jms_queue"></a>`wls_jms_queue`

This resource allows you to manage a Queue in a JMS Module of a WebLogic domain.

Here is an example on how you should use this:

    wls_jms_queue { 'jmsClusterModule:ErrorQueue':
      ensure            => 'present',
      defaulttargeting  => '0',
      distributed       => 1,
      expirationpolicy  => 'Discard',
      jndiname          => 'jms/ErrorQueue',
      redeliverydelay   => '-1',
      redeliverylimit   => '-1',
      subdeployment     => 'jmsServers',
      timetodeliver     => '-1',
      timetolive        => '-1',
      templatename      => 'Template',
      messagelogging    => 1,
      consumptionpaused => '0',
      insertionpaused   => '0',
      productionpaused  => '0',
    }

#### Properties

The following properties are available in the `wls_jms_queue` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_jms_queue` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_jms_queue` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_jms_quota"></a>`wls_jms_quota`

This resource allows you to manage a Quota in a JMS module of a WebLogic domain.

Here is an example on how you should use this:

    wls_jms_quota { 'jmsClusterModule:QuotaBig':
      ensure          => 'present',
      bytesmaximum    => '9223372036854775807',
      messagesmaximum => '9223372036854775807',
      policy          => 'FIFO',
      shared          => 1,,
    }

In this example you are managing a JMS quota in the default domain. When you want to
manage a JMS quota in a specific domain, you can use:

    wls_jms_quota { 'my_domain/jmsClusterModule:QuotaLow':
      ensure          => 'present',
      bytesmaximum    => '20000000000',
      messagesmaximum => '9223372036854775807',
      policy          => 'FIFO',
      shared          => '0',
    }

#### Properties

The following properties are available in the `wls_jms_quota` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_jms_quota` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_jms_quota` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_jms_security_policy"></a>`wls_jms_security_policy`

This resource allows you to manage security authorization policies in an WebLogic Security Realm.

#### Properties

The following properties are available in the `wls_jms_security_policy` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_jms_security_policy` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_jms_security_policy` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="wls_jms_sort_destination_key"></a>`wls_jms_sort_destination_key`

This resource allows you to manage the sort destination key in a JMS module of a WebLogic domain.

Here is an example on how you should use this:

    wls_jms_sort_destination_key { 'jmsClusterModule:JMSPriority':
      ensure        => 'present',
      key_type      => 'Int',
      property_name => 'JMSPriority',
      sort_order    => 'Descending',
    }

In this example you are managing a JMS sort destination key in the default domain. When you want to
manage a JMS sort destination key in a specific domain, you can use:

    wls_jms_sort_destination_key { 'my_domain/jmsClusterModule:JMSRedelivered':
      ensure        => 'present',
      key_type      => 'Boolean',
      property_name => 'JMSRedelivered',
      sort_order    => 'Ascending',
    }

#### Properties

The following properties are available in the `wls_jms_sort_destination_key` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_jms_sort_destination_key` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_jms_sort_destination_key` resource. You will seldom need to specify this ---
Puppet will usually discover the appropriate provider for your platform.

### <a name="wls_jms_subdeployment"></a>`wls_jms_subdeployment`

This resource allows you to manage a JMS subdeployment in a JMS module of a WebLogic domain.

Here is an example on how you should use this:

    wls_jms_subdeployment { 'jmsClusterModule:jmsServers':
      ensure     => 'present',
      target     => ['jmsServer1','jmsServer2'],
      targettype => ['JMSServer','JMSServer'],
    }

In this example you are managing a JMS subdeployment in the default domain. When you want to
manage a JMS subdeployment in a specific domain, you can use:

    wls_jms_subdeployment { 'my_domain/jmsClusterModule:wlsServers':
      ensure     => 'present',
      target     => ['WebCluster'],
      targettype => ['Cluster'],
    }

#### Properties

The following properties are available in the `wls_jms_subdeployment` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_jms_subdeployment` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_jms_subdeployment` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="wls_jms_template"></a>`wls_jms_template`

This resource allows you to manage a template in a JMS Module of a WebLogic domain.

Here is an example on how you should use this:

    wls_jms_template { 'jmsClusterModule:Template-0':
      ensure          => 'present',
      redeliverydelay => '-1',
      redeliverylimit => '-1',
    }

In this example you are managing a JMS template in the default domain. When you want to
manage a JMS template in a specific domain, you can use:

    wls_jms_template { 'my_domain/jmsClusterModule:Template-0':
      ensure          => 'present',
      redeliverydelay => '-1',
      redeliverylimit => '-1',
    }

#### Properties

The following properties are available in the `wls_jms_template` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_jms_template` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_jms_template` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_jms_topic"></a>`wls_jms_topic`

This resource allows you to manage a Tpoic in a JMS Module of a WebLogic domain.

Here is an example on how you should use this:

    wls_jms_topic { 'jmsClusterModule:Topic1':
      ensure            => 'present',
      balancingpolicy   => 'Round-Robin',
      defaulttargeting  => '0',
      deliverymode      => 'No-Delivery',
      destination_keys  => ['JMSPriority', 'JmsMessageId'],
      distributed       => 1,
      expirationpolicy  => 'Discard',
      forwardingpolicy  => 'Replicated',
      jndiname          => 'jms/Topic1',
      redeliverydelay   => '2000',
      redeliverylimit   => '2',
      subdeployment     => 'jmsServers',
      timetodeliver     => '-1',
      timetolive        => '300000',
      consumptionpaused => '0',
      insertionpaused   => '0',
      productionpaused  => '0',
    }

**WARNING** When you want to `absent` a topic. you must ensure that
the `distributed` parameter is specified.

    wls_jms_topic { 'jmsClusterModule:ErrorTopic':
      ensure      => 'absent',
      distributed => 1,
    }

Failure to specify the correct value for `distributed`, will result
in an error on removal of the topic.

#### Properties

The following properties are available in the `wls_jms_topic` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_jms_topic` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_jms_topic` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_jmsserver"></a>`wls_jmsserver`

This resource allows you to manage a jmsserver in an WebLogic domain.

Here is an example on how you should use this:

    wls_jmsserver { 'jmsServer1':
      ensure                      => 'present',
      persistentstore             => 'jmsFile1',
      persistentstoretype         => 'FileStore',
      target                      => ['wlsServer1'],
      targettype                  => ['Server'],
      allows_persistent_downgrade => '0',
      bytes_maximum               => '-1',
    }

In this example you are managing a JMS server in the default domain. When you want to
manage a JMS server in a specific domain, you can use:

    wls_jmsserver { 'my_domain/jmsServer2':
      ensure     => 'present',
      target     => ['wlsServer2'],
      targettype => ['Server'],
    }

#### Properties

The following properties are available in the `wls_jmsserver` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_jmsserver` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_jmsserver` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_jndi_security_policy"></a>`wls_jndi_security_policy`

This resource allows you to manage jndi security authorization policies in an WebLogic Security Realm.

Here is an example on how you should use this:

    wls_jndi_security_policy { 'domain/managed_server:javax.jms.TopicConnectionFactory:modify':
      ensure           => 'present',
      policyexpression => 'Role(Admin) | Role(Deployer)',
    }

This puppet snippit set's the security policy for `modify` operation of the the JNDI object
`javax.jms.TopicConnectionFactory` on server `managed_server` in the domain `domain`
to: `Role(Admin) | Role(Deployer)`.

#### Properties

The following properties are available in the `wls_jndi_security_policy` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_jndi_security_policy` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_jndi_security_policy` resource. You will seldom need to specify this ---
Puppet will usually discover the appropriate provider for your platform.

### <a name="wls_machine"></a>`wls_machine`

This resource allows you to manage machine in an WebLogic domain.

Here is an example on how you should use this:

    wls_machine { 'test2':
      ensure        => 'present',
      listenaddress => '10.10.10.10',
      listenport    => '5556',
      machinetype   => 'UnixMachine',
      nmtype        => 'SSL',
    }

In this example you are managing a machine in the default domain. When you want to
manage a machine in a specific domain, you can use:

    wls_machine { 'my_domain/test2':
      ensure        => 'present',
      listenaddress => '10.10.10.10',
      listenport    => '5556',
      machinetype   => 'UnixMachine',
      nmtype        => 'SSL',
    }

#### Properties

The following properties are available in the `wls_machine` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_machine` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_machine` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_mail_session"></a>`wls_mail_session`

This resource allows you to manage a mail_session in an WebLogic domain.

Here is an example on how you should use this:

    wls_mail_session { 'myMailSession':
      ensure         => 'present',
      jndiname       => 'myMailSession',
      target         => ['ManagedServer1', 'WebCluster'],
      targettype     => ['Server', 'Cluster'],
      mailproperty   => ['mail.host=smtp.hostname.com', 'mail.user=smtpadmin'],
    }

In this example you are managing a mail session in the default domain. When you want to
manage a mail session in a specific domain, you can use:

    wls_mail_session { 'my_domain/myMailSession':
      ensure         => 'present',
      jndiname       => 'myMailSession',
      target         => ['ManagedServer1', 'WebCluster'],
      targettype     => ['Server', 'Cluster'],
      mailproperty   => ['mail.host=smtp.hostname.com', 'mail.user=smtpadmin'],
    }

#### Properties

The following properties are available in the `wls_mail_session` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_mail_session` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_mail_session` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_managed_executor_service_template"></a>`wls_managed_executor_service_template`

Weblogic Server provides a preconfigured, default ManagedExecutorService for each application, and applications can easily use it in web or EJB components
without any configuration.

This resource allows you to manage a ManagedExecutorService in an WebLogic domain.

Here is an example on how you should use this:

    wls_managed_executor_service_template { 'default/ManagedExecutorServiceTemplate-0':
      ensure                               => 'present',
      deployment_order                     => '1000',
      long_running_priority                => '5',
      max_concurrent_long_running_requests => '10',
      target                               => ['ClusterJMS'],
      targettype                           => ['Cluster'],
    }

#### Properties

The following properties are available in the `wls_managed_executor_service_template` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_managed_executor_service_template` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_managed_executor_service_template` resource. You will seldom need to specify
this --- Puppet will usually discover the appropriate provider for your platform.

### <a name="wls_managedserver"></a>`wls_managedserver`

control a managed server or cluster state like running,stop,restart

Type for managed server control like start, running, abort and stop a managed server or a cluster.
Also supports `subscribe` with `refreshonly` when you only want to execute the restart when something
has changed.

Here is an example on how you should use this:

    wls_managedserver{'JMSServer1_Wls1036:':
      ensure                    => 'running',   #running|start|abort|stop
      target                    => 'Server', #Server|Cluster
      server_name               => 'JMSServer1',
      domain_name               => hiera('domain_name'),
      os_user                   => hiera('wls_os_user'),
      weblogic_home_dir         => hiera('wls_weblogic_home_dir'),
      weblogic_user             => hiera('wls_weblogic_user'),
      weblogic_password         => hiera('domain_wls_password'),
      jdk_home_dir              => hiera('wls_jdk_home_dir'),
      adminserver_address       => hiera('domain_adminserver_address'),
      adminserver_port          => hiera('domain_adminserver_port'),
    }

Here is an example with `refreshonly`. In this example, the restart will only be executed
when the domain `Wls1036`  is changed. A restart will be executed.

    wls_managedserver{'JMSServer1_Wls1036':
      ensure                    => 'restart',   #running|start|abort|stop
      target                    => 'Server',    #Server|Cluster
      server_name               => 'JMSServer1',
      domain_name               => hiera('domain_name'),
      os_user                   => hiera('wls_os_user'),
      weblogic_home_dir         => hiera('wls_weblogic_home_dir'),
      weblogic_user             => hiera('wls_weblogic_user'),
      weblogic_password         => hiera('domain_wls_password'),
      jdk_home_dir              => hiera('wls_jdk_home_dir'),
      adminserver_address       => hiera('domain_adminserver_address'),
      adminserver_port          => hiera('domain_adminserver_port'),
      refreshonly               => true,
      subscribe                 => Wls_domain['Wls1036'],
    }

#### Properties

The following properties are available in the `wls_managedserver` type.

##### `ensure`

Valid values: `start`, `stop`, `running`, `abort`

Aliases: `"running"=>"start", "abort"=>"stop"`

Whether to do something.

#### Parameters

The following parameters are available in the `wls_managedserver` type.

* [`adminserver_address`](#adminserver_address)
* [`adminserver_port`](#adminserver_port)
* [`domain_name`](#domain_name)
* [`jdk_home_dir`](#jdk_home_dir)
* [`name`](#name)
* [`os_user`](#os_user)
* [`provider`](#provider)
* [`refreshonly`](#refreshonly)
* [`server_name`](#server_name)
* [`target`](#target)
* [`weblogic_home_dir`](#weblogic_home_dir)
* [`weblogic_password`](#weblogic_password)
* [`weblogic_user`](#weblogic_user)

##### <a name="adminserver_address"></a>`adminserver_address`

The adminserver address.

##### <a name="adminserver_port"></a>`adminserver_port`

The adminserver port.

##### <a name="domain_name"></a>`domain_name`

The weblogic domain name.

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

The jdk home dir.

##### <a name="name"></a>`name`

namevar

The title.

##### <a name="os_user"></a>`os_user`

The weblogic operating system user.

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_managedserver` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

##### <a name="refreshonly"></a>`refreshonly`

Valid values: ``true``, ``false``

The command should only be run as a
refresh mechanism for when a dependent object is changed.

Default value: ``false``

##### <a name="server_name"></a>`server_name`

The adminserver name.

##### <a name="target"></a>`target`

The weblogic type.

##### <a name="weblogic_home_dir"></a>`weblogic_home_dir`

The weblogic home folder.

##### <a name="weblogic_password"></a>`weblogic_password`

The weblogic user password.

##### <a name="weblogic_user"></a>`weblogic_user`

The weblogic user.

### <a name="wls_messaging_bridge"></a>`wls_messaging_bridge`

This resource allows you to manage a messaging bridge in an WebLogic domain.

Here is an example on how you should use this:

    wls_messaging_bridge { 'myBrigde':
      ensure                 => 'present',
      asyncenabled           => 1,
      batchinterval          => '-1',
      batchsize              => '10',
      durabilityenabled      => 1,
      idletimemax            => '60',
      qos                    => 'Exactly-once',
      reconnectdelayincrease => '5',
      reconnectdelaymax      => '60',
      reconnectdelaymin      => '15',
      selector               => 'sel',
      transactiontimeout     => '30',
      sourcedestination      => 'mySourceBrigdeDest',
      targetdestination      => 'MyDestBridgeDest',
      target                 => ['ManagedServer1', 'WebCluster'],
      targettype             => ['Server', 'Cluster'],
    }

In this example you are managing a message bridge in the default domain. When you want to
manage a message bridge in a specific domain, you can use:

    wls_messaging_bridge { 'my_domain/myBrigde':
      ensure                 => 'present',
      asyncenabled           => 1,
      batchinterval          => '-1',
      batchsize              => '10',
      durabilityenabled      => 1,
      idletimemax            => '60',
      qos                    => 'Exactly-once',
      reconnectdelayincrease => '5',
      reconnectdelaymax      => '60',
      reconnectdelaymin      => '15',
      selector               => 'sel',
      transactiontimeout     => '30',
      sourcedestination      => 'mySourceBrigdeDest',
      targetdestination      => 'MyDestBridgeDest',
      target                 => ['ManagedServer1', 'WebCluster'],
      targettype             => ['Server', 'Cluster'],
    }

Check [the documentation](https://javamail.java.net/nonav/docs/api/) for valid messaging bridge properties.

#### Properties

The following properties are available in the `wls_messaging_bridge` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_messaging_bridge` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_messaging_bridge` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="wls_migratable_target"></a>`wls_migratable_target`

This resource allows you to managed migratable targets in a WebLogic domain.

Here is an example on how you should use this:

    wls_migratable_target { 'wlsServer1 (migratable)':
      ensure                     => 'present',
      cluster                    => 'WebCluster',
      migration_policy           => 'manual',
      number_of_restart_attempts => '6',
      seconds_between_restarts   => '30',
      user_preferred_server      => 'wlsServer1',
    }

In this example you are managing a migratable target in the default domain. When you want to
manage a migratable target in a specific domain, you can use:

    wls_migratable_target { 'my_domain/wlsServer2 (migratable)':
      ensure                     => 'present',
      cluster                    => 'WebCluster',
      migration_policy           => 'manual',
      number_of_restart_attempts => '6',
      seconds_between_restarts   => '30',
      user_preferred_server      => 'wlsServer2',
    }

Here are some more examples:

    wls_migratable_target { 'Wls11gSetting/wlsServer1 (migratable)':
      ensure                     => 'present',
      cluster                    => 'WebCluster',
      migration_policy           => 'manual',
      number_of_restart_attempts => '6',
      seconds_between_restarts   => '30',
      user_preferred_server      => 'wlsServer1',
    }
    wls_migratable_target { 'Wls11gSetting/wlsServer2 (migratable)':
      ensure                     => 'present',
      cluster                    => 'WebCluster',
      migration_policy           => 'manual',
      number_of_restart_attempts => '6',
      seconds_between_restarts   => '30',
      user_preferred_server      => 'wlsServer2',
    }

#### Properties

The following properties are available in the `wls_migratable_target` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_migratable_target` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_migratable_target` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="wls_multi_datasource"></a>`wls_multi_datasource`

This resource allows you to manage a multi datasource in an WebLogic domain.

Here is an example on how you should use this:

    wls_multi_datasource { 'myMultiDatasource':
      ensure        => 'present',
      algorithmtype => 'Failover',
      datasources   => ['myJDBCDatasource'],
      jndinames     => ['myMultiDatasource'],
      target         => ['ManagedServer1', 'WebCluster'],
      targettype     => ['Server', 'Cluster'],
      testfrequency => '120',
    }

In this example you are managing a multi datasource in the default domain. When you want to
manage a multi datasource in a specific domain, you can use:

    wls_multi_datasource { 'my_domain/myMultiDatasource':
      ensure        => 'present',
      algorithmtype => 'Failover',
      datasources   => ['myJDBCDatasource'],
      jndinames     => ['myMultiDatasource'],
      target         => ['ManagedServer1', 'WebCluster'],
      targettype     => ['Server', 'Cluster'],
      testfrequency => '120',
    }

#### Properties

The following properties are available in the `wls_multi_datasource` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_multi_datasource` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_multi_datasource` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="wls_opatch"></a>`wls_opatch`

This resource allows you to manage opatch patches on a specific middleware home.

wls_opatch {'/opt/oracle/middleware12c:16175470':
  ensure                  => "present",
  jdk_home_dir            => "/usr/java/jdk1.7.0_45",
  os_user                 => "oracle",
  source                  => "/vagrant/p16175470_121200_Generic.zip",
}

#### Properties

The following properties are available in the `wls_opatch` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_opatch` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_opatch` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

### <a name="wls_path_service"></a>`wls_path_service`

This resource allows you to manage path servers

Here is an example on how you should use this:

    wls_path_service { 'jmy_service':
      ensure              => 'present',
      target              => ['MyCluster'],
      targettype          => ['Cluster'],
      persistentstore     => 'mystore',
      persistentstoretype => 'JDBCStore',
    }

#### Properties

The following properties are available in the `wls_path_service` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_path_service` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_path_service` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_rcu"></a>`wls_rcu`

This is the Oracle WebLogic RCU ( Repository creation utility) installer type

#### Properties

The following properties are available in the `wls_rcu` type.

##### `ensure`

Valid values: `present`, `absent`, `create`, `delete`

Aliases: `"create"=>"present", "delete"=>"absent"`

Whether a Repository should be created.

#### Parameters

The following parameters are available in the `wls_rcu` type.

* [`check_script`](#check_script)
* [`jdbc_url`](#jdbc_url)
* [`jdk_home_dir`](#jdk_home_dir)
* [`name`](#name)
* [`oracle_home`](#oracle_home)
* [`os_user`](#os_user)
* [`provider`](#provider)
* [`statement`](#statement)
* [`sys_password`](#sys_password)
* [`sys_user`](#sys_user)

##### <a name="check_script"></a>`check_script`

The check_script py script for the RCU Repository.

##### <a name="jdbc_url"></a>`jdbc_url`

The jdbc url for the RCU check.

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

The jdk_home_dir.

##### <a name="name"></a>`name`

namevar

The prefix of the RCU.

##### <a name="oracle_home"></a>`oracle_home`

The oracle_home for the WLST location.

##### <a name="os_user"></a>`os_user`

The weblogic operating system user.

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_rcu` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

##### <a name="statement"></a>`statement`

The RCU statement.

##### <a name="sys_password"></a>`sys_password`

The sys password for the RCU check/install.

##### <a name="sys_user"></a>`sys_user`

The sys user for the RCU check/install.

### <a name="wls_resource_group_template"></a>`wls_resource_group_template`

This resource allows you to manage resource group template in an WebLogic 12.2.1 domain.

#### Properties

The following properties are available in the `wls_resource_group_template` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_resource_group_template` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_resource_group_template` resource. You will seldom need to specify this ---
Puppet will usually discover the appropriate provider for your platform.

### <a name="wls_resource_group_template_deployment"></a>`wls_resource_group_template_deployment`

TThis resource allows you to manage deployments in a resource group template in an WebLogic 12.2.1 domain.

#### Properties

The following properties are available in the `wls_resource_group_template_deployment` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_resource_group_template_deployment` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_resource_group_template_deployment` resource. You will seldom need to specify
this --- Puppet will usually discover the appropriate provider for your platform.

### <a name="wls_role"></a>`wls_role`

This resource allows you to manage roles an WebLogic Secuirty Realm.

#### Properties

The following properties are available in the `wls_role` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_role` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_role` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

### <a name="wls_saf_error_handler"></a>`wls_saf_error_handler`

This resource allows you to manage a SAF Error Handler in a JMS Module of a WebLogic domain.

Here is an example on how you should use this:

    wls_saf_error_handler { 'jmsClusterModule:ErrorHandling-0':
      ensure => 'present',
      policy => 'Discard',
    }

In this example you are managing a SAF error handler in the default domain. When you want to
manage a SAF error handler in a specific domain, you can use:

    wls_saf_error_handler { 'my_domain/jmsClusterModule:ErrorHandling-1':
      ensure    => 'present',
      logformat => '%header%%properties%',
      policy    => 'Log',
    }

#### Properties

The following properties are available in the `wls_saf_error_handler` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_saf_error_handler` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_saf_error_handler` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="wls_saf_imported_destination"></a>`wls_saf_imported_destination`

This resource allows you to manage a SAF imported destinations in a JMS Module of a WebLogic domain.

Here is an example on how you should use this:

    wls_saf_imported_destination { 'jmsClusterModule:SAFImportedDestinations-0':
      ensure               => 'present',
      defaulttargeting     => 1,
      errorhandling        => 'ErrorHandling-0',
      jndiprefix           => 'saf_',
      remotecontext        => 'RemoteSAFContext-0',
      timetolivedefault    => '1000000000',
      usetimetolivedefault => 1,,
    }

In this example you are managing a SAF imported destination in the default domain. When you want to
manage a SAF imported destination in a specific domain, you can use:

    wls_saf_imported_destination { 'my_domain/jmsClusterModule:SAFImportedDestinations-1':
      ensure               => 'present',
      defaulttargeting     => '0',
      jndiprefix           => 'saf2_',
      remotecontext        => 'RemoteSAFContext-1',
      subdeployment        => 'safServers',
      usetimetolivedefault => '0',
    }

#### Properties

The following properties are available in the `wls_saf_imported_destination` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_saf_imported_destination` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_saf_imported_destination` resource. You will seldom need to specify this ---
Puppet will usually discover the appropriate provider for your platform.

### <a name="wls_saf_imported_destination_object"></a>`wls_saf_imported_destination_object`

This resource allows you to manage a SAF imported destinations object in a JMS Module of a WebLogic domain.

Here is an example on how you should use this:

    wls_saf_imported_destination_object { 'jmsClusterModule:SAFImportedDestinations-0:SAFDemoQueue':
      ensure               => 'present',
      nonpersistentqos     => 'Exactly-Once',
      object_type          => 'queue',
      remotejndiname       => 'jms/DemoQueue',
      unitoforderrouting   => 'Hash',
      usetimetolivedefault => '0',
    }

In this example you are managing a SAF imported destination object in the default domain. When you want to
manage a SAF imported destination object in a specific domain, you can use:

    wls_saf_imported_destination_object { 'my_domain/jmsClusterModule:SAFImportedDestinations-0:SAFDemoTopic':
      ensure               => 'present',
      nonpersistentqos     => 'Exactly-Once',
      object_type          => 'topic',
      remotejndiname       => 'jms/DemoTopic',
      timetolivedefault    => '100000000',
      unitoforderrouting   => 'Hash',
      usetimetolivedefault => 1,
    }

#### Properties

The following properties are available in the `wls_saf_imported_destination_object` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_saf_imported_destination_object` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_saf_imported_destination_object` resource. You will seldom need to specify
this --- Puppet will usually discover the appropriate provider for your platform.

### <a name="wls_saf_remote_context"></a>`wls_saf_remote_context`

This resource allows you to manage a SAF remote contexts in a JMS Module of a WebLogic domain.

Here is an example on how you should use this:

    wls_saf_remote_context { 'jmsClusterModule:RemoteSAFContext-0':
      ensure        => 'present',
      connect_url   => 't3://10.10.10.10:7001',
      weblogic_user => 'weblogic',
      weblogic_password => 'weblogic1',
    }

In this example you are managing a SAF remote contexts in the default domain. When you want to
manage a SAF remote contexts in a specific domain, you can use:

    wls_saf_remote_context { 'my_domain/jmsClusterModule:RemoteSAFContext-1':
      ensure      => 'present',
      connect_url => 't3://10.10.10.10:7001',
    }

#### Properties

The following properties are available in the `wls_saf_remote_context` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_saf_remote_context` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_saf_remote_context` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="wls_safagent"></a>`wls_safagent`

This resource allows you to manage a SAF agent in an WebLogic domain.

Here is an example on how you should use this:

    wls_safagent { 'jmsSAFAgent1':
      ensure              => 'present',
      persistentstore     => 'jmsFileSAFAgent1',
      persistentstoretype => 'FileStore',
      servicetype         => 'Sending-only',
      target              => ['wlsServer1'],
      targettype          => ['Server'],
    }

In this example you are managing a SAF agent in the default domain. When you want to
manage a SAF agent in a specific domain, you can use:

    wls_safagent { 'my_domain/jmsSAFAgent2':
      ensure      => 'present',
      servicetype => 'Both',
      target      => ['wlsServer2'],
      targettype  => ['Server'],
    }

#### Properties

The following properties are available in the `wls_safagent` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_safagent` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_safagent` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_security_policy"></a>`wls_security_policy`

This resource allows you to manage security authorization policies in an WebLogic Security Realm.

#### Properties

The following properties are available in the `wls_security_policy` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_security_policy` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_security_policy` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="wls_security_realm"></a>`wls_security_realm`

This resource allows you to manage an existing security realm.

Here is an example on how you can do this:
    wls_security_realm { 'my_domain/myrealm':
      ensure                                      => 'absent',
      auto_restart_on_non_dynamic_changes         => 0,
      combined_role_mapping_enabled               => 1,
      delegate_mbean_authorization                => 1,
      deployable_provider_synchronization_enabled => 0,
      deployable_provider_synchronization_timeout => 60000,
      fully_delegate_authorization                => 0,
      retire_timeout_seconds                      => 60,
      security_dd_model                           => 'DDOnly',
    }

At this point in type Puppet doesn't support creating a new security realm or
removing an existing realm.

#### Properties

The following properties are available in the `wls_security_realm` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_security_realm` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_security_realm` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_server"></a>`wls_server`

This resource allows you to manage server in an WebLogic domain.

Here is an example on how you should use this:

    wls_server { 'wlsServer2':
      ensure                            => 'present',
      arguments                         => '-XX:PermSize=256m -XX:MaxPermSize=256m -Xms752m -Xmx752m -Dweblogic.Stdout=/var/log/weblogic/wlsServer2.out -Dweblogic.Stderr=/var/log/weblogic/wlsServer2_err.out',
      jsseenabled                       => '0',
      listenaddress                     => '10.10.10.200',
      listenport                        => '8001',
      listenportenabled                 => 1,
      log_file_min_size                 => '2000',
      log_filecount                     => '10',
      log_number_of_files_limited       => 1,
      log_rotate_logon_startup          => 1,
      log_rotationtype                  => 'bySize',
      logfilename                       => '/var/log/weblogic/wlsServer2.log',
      log_datasource_filename           => 'logs/datasource.log',
      log_http_filename                 => 'logs/access.log',
      log_http_format                   => 'date time cs-method cs-uri sc-status',
      log_http_format_type              => 'common',
      log_http_file_count               => '10',
      log_http_number_of_files_limited  => '0',
      log_redirect_stderr_to_server     => '0',
      log_redirect_stdout_to_server     => '0',
      logintimeout                      => '5000',
      restart_max                       => '2',
      machine                           => 'Node2',
      sslenabled                        => 1,
      sslhostnameverificationignored    => 1,
      ssllistenport                     => '8201',
      two_way_ssl                       => '0',
      client_certificate_enforced       => '0',
      default_file_store                => '/path/to/default_file_store/',
      max_message_size                  => '25000000',
      weblogic_plugin_enabled           => 1,
    }

In this example you are managing a managed server in the default domain. When you want to
manage a managed server in a specific domain, you can use:

    wls_server { 'my_domain/wlsServer1':
      ensure                            => 'present',
      arguments                         => '-XX:PermSize=256m -XX:MaxPermSize=256m -Xms752m -Xmx752m -Dweblogic.Stdout=/var/log/weblogic/wlsServer1.out -Dweblogic.Stderr=/var/log/weblogic/wlsServer1_err.out',
      jsseenabled                       => '0',
      listenaddress                     => '10.10.10.100',
      listenport                        => '8001',
      listenportenabled                 => 1,
      machine                           => 'Node1',
      sslenabled                        => '0',
      tunnelingenabled                  => '0',
      max_message_size                  => '10000000',
    }

#### Properties

The following properties are available in the `wls_server` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_server` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_server` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

### <a name="wls_server_channel"></a>`wls_server_channel`

This resource allows you to manage a server channel in an WebLogic domain.

Here is an example on how you should use this:

    wls_server_channel { 'wlsServer1:Channel-Cluster':
      ensure                      => 'present',
      channel_identity_customized => '0',
      client_certificate_enforced => '0',
      custom_identity_alias       => 'node1',
      enabled                     => 1,
      httpenabled                 => 1,
      listenaddress               => '10.10.10.100',
      listenport                  => '8003',
      max_message_size            => '25000000',
      outboundenabled             => '0',
      protocol                    => 'cluster-broadcast',
      publicaddress               => '10.10.10.100',
      publicport                  => '8003',
      tunnelingenabled            => '0',
      two_way_ssl                 => '0',
    }

In this example you are managing a server channel in the default domain. When you want to
manage a server channel in a specific domain, you can use:

    wls_server_channel { 'my_domain/wlsServer1:HTTP':
      ensure                      => 'present',
      channel_identity_customized => '0',
      client_certificate_enforced => '0',
      custom_identity_alias       => 'node1',
      enabled                     => 1,
      httpenabled                 => 1,
      listenport                  => '8004',
      max_message_size            => '35000000',
      outboundenabled             => '0',
      protocol                    => 'http',
      publicport                  => '8104',
      tunnelingenabled            => '0',
      two_way_ssl                 => '0',
    }

Here are some more examples:

    wls_server_channel { 'default/wlsServer2:Channel-Cluster':
      ensure                      => 'present',
      channel_identity_customized => '0',
      client_certificate_enforced => '0',
      custom_identity_alias       => 'node2',
      enabled                     => 1,
      httpenabled                 => 1,
      listenaddress               => '10.10.10.200',
      listenport                  => '8003',
      max_message_size            => '25000000',
      outboundenabled             => '0',
      protocol                    => 'cluster-broadcast',
      publicaddress               => '10.10.10.200',
      publicport                  => '8003',
      tunnelingenabled            => '0',
      two_way_ssl                 => '0',
    }

    wls_server_channel { 'default/wlsServer2:HTTP':
      ensure                      => 'present',
      channel_identity_customized => '0',
      client_certificate_enforced => '0',
      custom_identity_alias       => 'node2',
      enabled                     => 1,
      httpenabled                 => 1,
      listenport                  => '8004',
      max_message_size            => '35000000',
      outboundenabled             => '0',
      protocol                    => 'http',
      publicport                  => '8104',
      tunnelingenabled            => '0',
      two_way_ssl                 => '0',
    }

#### Properties

The following properties are available in the `wls_server_channel` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_server_channel` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_server_channel` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_server_template"></a>`wls_server_template`

This resource allows you to manage server templates in an WebLogic domain.

Here is an example on how you should use this:

    wls_server_template { 'ServerTemplateWeb':
      ensure        => 'present',
      arguments     => ['-XX:PermSize=256m','-XX:MaxPermSize=256m'],
      listenport    => '9101',
      sslenabled    => 1,
      ssllistenport => '9102',
    }

In this example you are managing a server template in the default domain. When you want to
manage a server template in a specific domain, you can use:

    wls_server_template { 'my_domain/ServerTemplateWeb':
      ensure        => 'present',
      arguments     => ['-XX:PermSize=256m','-XX:MaxPermSize=256m'],
      listenport    => '9101',
      sslenabled    => 1,
      ssllistenport => '9102',
    }

#### Properties

The following properties are available in the `wls_server_template` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_server_template` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_server_template` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="wls_server_tlog"></a>`wls_server_tlog`

This resource allows you to manage server tlog in an WebLogic domain.

Here is an example on how you should use this:

    wls_server_tlog { 'JmsWlsServer1':
      ensure                 => 'present',
      tlog_datasource        => 'tlogDS',
      tlog_datasource_prefix => 'TLOG_JmsWlsServer1_',
      tlog_enabled           => 'true',
    }

In this example you are managing a server tlog in the default domain. When you want to
manage a server tlog in a specific domain, you can use:

    wls_server_tlog { 'my_domain/WebServer1':
      ensure                 => 'present',
      tlog_datasource        => 'tlogDS',
      tlog_datasource_prefix => 'TLOG_WebServer1_',
      tlog_enabled           => 'true',
    }

#### Properties

The following properties are available in the `wls_server_tlog` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_server_tlog` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_server_tlog` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_setting"></a>`wls_setting`

This resource allows you to set the defaults for all other wls types.


All wls types needs a `wls_setting` definition. This is a pointer to an WebLogic AdminServer and
you need to create one for every WebLogic domain. When you don't provide a `wls_setting` identifier
in the title of the weblogic type then it will use `default` as identifier.

Here is an example on how to create the `default` settings:

    wls_setting { 'default':
      user               => 'oracle',
      weblogic_home_dir  => '/opt/oracle/middleware11g/wlserver_10.3',
      connect_url        => "t3://localhost:7001",
      weblogic_user      => 'weblogic',
      weblogic_password  => 'weblogic1',
    }

When you want to create an other domain, like for instance `domain2`. You use `wls_setting like this:

    wls_setting { 'domain2':
      user               => 'oracle',
      weblogic_home_dir  => '/opt/oracle/middleware11g/wlserver_10.3',
      connect_url        => "t3://localhost:7011",
      weblogic_user      => 'weblogic',
      weblogic_password  => 'weblogic1',
      post_classpath     => '/opt/oracle/wlsdomains/domains/Wls1036/lib/aa.jar',
      extra_properties   => ['wls_server:.*'],
    }

#### Parameters

The following parameters are available in the `wls_setting` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_setting` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_singleton_service"></a>`wls_singleton_service`

This resource allows you to managed singleton services in a WebLogic domain.

Here is an example on how you should use this:

    wls_singleton_service { 'SingletonService':
        ensure                           => 'present',
        cluster                          => 'ClusterName',
        user_preferred_server            => 'PreferredServerName',
        class_name                       => 'com.example.package.SingletonServiceImpl',
        constrained_candidate_servers    => ['PreferredServerName', 'OtherServerName'],
        additional_migration_attempts    => 2,
        millis_to_sleep_between_attempts => 300000,
        notes                            => 'This is a singleton service that prefers to run on PreferredServerName, but can be migrated to OtherServerName.',
    }

In this example you are managing a singleton service in the default domain. When you want to
manage a singleton service in a specific domain, you can use:

      wls_singleton_service { 'my_domain/SingletonService':
        ensure                           => 'present',
        cluster                          => 'ClusterName',
        user_preferred_server            => 'PreferredServerName',
        class_name                       => 'com.example.package.SingletonServiceImpl',
        constrained_candidate_servers    => ['PreferredServerName', 'OtherServerName'],
        additional_migration_attempts    => 2,
        millis_to_sleep_between_attempts => 300000,
        notes                            => 'This is a singleton service that prefers to run on PreferredServerName, but can be migrated to OtherServerName.',
    }

#### Properties

The following properties are available in the `wls_singleton_service` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_singleton_service` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_singleton_service` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="wls_user"></a>`wls_user`

This resource allows you to manage user in an WebLogic Security Realm.

Here is an example on how you should use this:

    wls_user { 'OracleSystemUser':
      ensure                 => 'present',
      authenticationprovider => 'DefaultAuthenticator',
      description            => 'Oracle application software system user.',
      realm                  => 'myrealm',
    }

In this example you are managing a user in the default domain. When you want to
manage a user in a specific domain, you can use:

    # this will use default as wls_setting identifier
    wls_user { 'my_domain/testuser1':
      ensure                 => 'present',
      authenticationprovider => 'DefaultAuthenticator',
      description            => 'testuser1',
      realm                  => 'myrealm',
    }

#### Properties

The following properties are available in the `wls_user` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_user` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_user` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

### <a name="wls_virtual_host"></a>`wls_virtual_host`

This resource allows you to manage virtual host in an WebLogic domain.

Here is an example on how you should use this:

    wls_virtual_host { 'WS':
      ensure             => 'present',
      channel            => 'HTTP',
      target             => ['WebCluster'],
      targettype         => ['Cluster'],
      virtual_host_names => ['admin.example.com','10.10.10.10'],
    }

In this example you are managing a virtual host in the default domain. When you want to
manage a virtual host in a specific domain, you can use:

    wls_virtual_host { 'my_domain/WS':
      ensure             => 'present',
      channel            => 'HTTP',
      target             => ['WebCluster'],
      targettype         => ['Cluster'],
      virtual_host_names => ['admin.example.com','10.10.10.10'],
    }

#### Properties

The following properties are available in the `wls_virtual_host` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_virtual_host` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_virtual_host` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_virtual_target"></a>`wls_virtual_target`

This resource allows you to manage virtual targets in an WebLogic 12.2.1 domain.

#### Properties

The following properties are available in the `wls_virtual_target` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_virtual_target` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_virtual_target` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_workmanager"></a>`wls_workmanager`

This resource allows you to manage workmanagers in an WebLogic domain.

Here is an example on how you should use this:

    wls_workmanager { 'WorkManagerConstraints':
      ensure                => 'present',
      capacity              => 'CapacityConstraint',
      maxthreadsconstraint  => 'MaxThreadsConstraint',
      minthreadsconstraint  => 'MinThreadsConstraint',
      fairsharerequestclass => 'FairShareReqClass',
      stuckthreads          => '0',
      target                => ['WebCluster'],
      targettype            => ['Cluster'],
    }

In this example you are managing a work manager in the default domain. When you want to
manage a work manager in a specific domain, you can use:

    wls_workmanager { 'my_domain/WorkManagerConstraints':
      ensure                => 'present',
      capacity              => 'CapacityConstraint',
      maxthreadsconstraint  => 'MaxThreadsConstraint',
      minthreadsconstraint  => 'MinThreadsConstraint',
      fairsharerequestclass => 'FairShareReqClass',
      stuckthreads          => '0',
      target                => ['WebCluster'],
      targettype            => ['Cluster'],
    }

#### Properties

The following properties are available in the `wls_workmanager` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_workmanager` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_workmanager` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="wls_workmanager_constraint"></a>`wls_workmanager_constraint`

This resource allows you to manage work manager constraints in an WebLogic domain.

Here is an example on how you should use this:

    wls_workmanager_constraint { 'CapacityConstraint':
      ensure          => 'present',
      constrainttype  => 'Capacity',
      constraintvalue => '20',
      target          => ['WebCluster'],
      targettype      => ['Cluster'],
    }

In this example you are managing a work manager contraint in the default domain. When you want to
manage a work manager contraint in a specific domain, you can use:

    wls_workmanager_constraint { 'my_domain/MaxThreadsConstraint':
      ensure          => 'present',
      constrainttype  => 'MaxThreadsConstraint',
      constraintvalue => '5',
      target          => ['WebCluster'],
      targettype      => ['Cluster'],
    }

Here are some more examples:

    wls_workmanager_constraint { 'MinThreadsConstraint':
      ensure          => 'present',
      constrainttype  => 'MinThreadsConstraint',
      constraintvalue => '2',
      target          => ['WebCluster'],
      targettype      => ['Cluster'],
    }
    wls_workmanager_constraint { 'FairShareReqClass':
      ensure          => 'present',
      constrainttype  => 'FairShareRequestClasses',
      constraintvalue => '50',
      target          => ['WebCluster'],
      targettype      => ['Cluster'],
    }

#### Properties

The following properties are available in the `wls_workmanager_constraint` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `wls_workmanager_constraint` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_workmanager_constraint` resource. You will seldom need to specify this ---
Puppet will usually discover the appropriate provider for your platform.

## Tasks

### <a name="start_managed_servers"></a>`start_managed_servers`

Start all managed servers in a specified domain except the servers on the skip list

**Supports noop?** false

#### Parameters

##### `domain`

Data type: `Optional[String[1]]`

The wls_config identifier of the domain. The default is 'default'

##### `skip`

Data type: `Optional[Array[String[1]]]`

The list of managed servers you DON'T want to start. e.g. skip.

##### `wait`

Data type: `Optional[Variant[Boolean, String]]`

Indicate if you want to wait for the startup to be finished. The default is true.

##### `timeout`

Data type: `Optional[Variant[Integer,String]]`

Time to wait for startup te be succesful if we wait for it to be finished. Default is 300 seconds.

### <a name="stop_adminserver"></a>`stop_adminserver`

Stop the admin server in a specified domain expect the Admin Server and the servers on the skip list

**Supports noop?** false

#### Parameters

##### `domain`

Data type: `Optional[String[1]]`

The wls_config identifier of the domain. The default is 'default'

##### `admin_server`

Data type: `Optional[String[1]]`

The name of the Admin Server process. The default is 'AdminServer'

##### `wait`

Data type: `Optional[Variant[Boolean, String]]`

Indicate if you want to wait for the shutdown to be finished. The default is true.

##### `timeout`

Data type: `Optional[Variant[Integer,String]]`

Time to wait for shutdown te be succesful if we wait for it to be finished. Default is 300 seconds.

### <a name="stop_managed_servers"></a>`stop_managed_servers`

Stop all managed servers in a specified domain except the Admin Server and the servers on the skip list

**Supports noop?** false

#### Parameters

##### `domain`

Data type: `Optional[String[1]]`

The wls_config identifier of the domain. The default is 'default'

##### `skip`

Data type: `Optional[Array[String[1]]]`

The list of managed servers you DON'T want to stop. e.g. skip.

##### `wait`

Data type: `Optional[Variant[Boolean, String]]`

Indicate if you want to wait for the shutdown to be finished. The default is true.

##### `timeout`

Data type: `Optional[Variant[Integer,String]]`

Time to wait for shutdown te be succesful if we wait for it to be finished. Default is 300 seconds.

