# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# WebLogic Features module
module WebLogicFeature
  def self.weblogic_running_check
    `ps -ef | egrep "^.*/java .* weblogic.Server$"` != ''
  end

  Puppet.features.add(:weblogic_running) do
    weblogic_running_check
  end

  Puppet.features.send :meta_def, 'weblogic_running?' do
    name = :weblogic_running
    final = @results[name]
    @results[name] = WebLogicFeature.weblogic_running_check unless final
    @results[name]
  end
end
