# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:datasourceforjobscheduler, :parent => Puppet::Parameter::WlsProperty) do
  include EasyType::Validators::Name

  desc <<-DESC

  data source required to support persistence of jobs scheduled with the job scheduler

  An example on how to use this:

        wls_cluster { 'aCluster':
          ...
          datasourceforjobscheduler => 'schedulerDatasource',
          ...
        }

  DESC

  data_type('Optional[String]')

  maps_to('DataSourceForJobScheduler/')

  on_apply do
    apply_paths_with_reference('/JDBCSystemResources', value)
  end
end
