# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:jta_parallel_xa_dispatch_policy, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  The dispatch policy to use when performing XA operations in parallel.

  An example on how to use this:

      wls_cluster {a_wls_cluster :
         ...
         jta_parallel_xa_dispatch_policy => 'a_value'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_cluster:jta_parallel_xa_dispatch_policy']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  data_type('Optional[String]')

  maps_to('JTACluster/%<cluster_name>s/ParallelXADispatchPolicy')
end
