# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:millis_to_sleep_between_auto_migration_attempts, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  Controls how long of a pause there should be between the migration attempts described in getAdditionalAutoMigrationAttempts(). Note that this delay only happens when the server has failed to come up on every machine.

  An example on how to use this:

      wls_cluster {a_wls_cluster :
         ...
         millis_to_sleep_between_auto_migration_attempts => '180000'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_cluster:millis_to_sleep_between_auto_migration_attempts']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC
  include EasyType::Types::Integer
  data_type("Optional[Variant[Enum['absent'],Integer]]")

  maps_to('MillisToSleepBetweenAutoMigrationAttempts')
end
