# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:multicast_buffer_size, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  The multicast socket send/receive buffer size (at least 64 kilobytes).  Returns the multicast socket send/receive buffer size.

  An example on how to use this:

      wls_cluster {a_wls_cluster :
         ...
         multicast_buffer_size => '64'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_cluster:multicast_buffer_size']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC
  include EasyType::Types::Integer
  data_type("Optional[Variant[Enum['absent'],Integer]]")

  maps_to('MulticastBufferSize')
end
