# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:multicast_ttl, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  The number of network hops (between 1 and 255) that a cluster multicast message is allowed to travel.  Defines the number of network hops that a cluster multicast message is allowed to travel. 1 restricts the cluster to one subnet.

  An example on how to use this:

      wls_cluster {a_wls_cluster :
         ...
         multicast_ttl => 1,
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_cluster:multicast_ttl']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  maps_to('MulticastTTL')
  include EasyType::Types::Integer
  data_type("Optional[Variant[Enum['absent'],Integer]]")
end
