# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:number_of_servers_in_cluster_address, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  Number of servers to be listed from this cluster when generating a cluster address automatically. This setting has no effect if Cluster Address is explicitly set.

  An example on how to use this:

      wls_cluster {a_wls_cluster :
         ...
         number_of_servers_in_cluster_address => '3'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_cluster:number_of_servers_in_cluster_address']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  data_type('Optional[String]')

  maps_to('NumberOfServersInClusterAddress')
end
