# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:messagingmode, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  Specifies the messaging type used in the cluster. Multicast messaging is provided for backwards compatibility.

  Here is an example on how to use this:
      wls_cluster { 'aCluster':
        ...
        messagingmode => 'multicast',
        ...
      }

  DESC

  newvalues('absent', 'multicast', 'unicast')

  maps_to('ClusterMessagingMode')
  data_type("Optional[Enum['absent','multicast','unicast']]")
end
