# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:migration_datasource, :parent => Puppet::Parameter::WlsProperty) do
  include EasyType::Validators::Name

  desc <<-DESC
  The data source used by servers in the cluster during migration. (You must configure each Migratable Server within the cluster to use this data source.)

  Here is an example on how to use this:

      wls_cluster { 'aCluster':
        ...
        migration_datasource => 'mydatasourcename',
        ...
      }

  DESC

  data_type('Optional[String]')

  maps_to('DataSourceForAutomaticMigration/')

  on_apply do
    apply_paths_with_reference('/JDBCSystemResources', value)
  end
end
