# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:start_class_path, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  The classpath (path on the machine running Node Manager) to use when starting this server.  If you need to add user classes to the classpath, in addition you will need to add the following: <code>FEATURES_HOME/weblogic.server.modules.coherence.server_10.3.4.0.jar:COHERENCE_HOME/lib/coherence.jar</code>  where <code>FEATURES_HOME</code> is the features directory (typically <code>$MW_HOME/modules/features</code>) and <code>COHERENCE_HOME</code> the coherence directory (typically <code>$MW_HOME/coherence_3.6</code>) on the Node Manager machine. If you do not specify a classpath the above will be used automatically.   The operating system determines which character separates path elements. On Windows, use a semicolon (;). On UNIX a colon (:).

  An example on how to use this:

      wls_coherence_server {a_wls_coherence_server :
         ...
         start_class_path => 'a_value'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_coherence_server:start_class_path']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  data_type('Optional[String]')

  maps_to('CoherenceServerStart/%<coherence_server_name>s/ClassPath')
end
