# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:deployment_order) do
  include EasyType
  include EasyType::Types::Integer

  desc <<-DESC
    An integer value that indicates when this unit is deployed, relative to other deployable units on a server, during startup.
    Units with lower values are deployed before those with higher values.

  DESC

  data_type("Optional[Variant[Enum['absent'],Integer]]")

  to_translate_to_resource do |raw_resource|
    raw_resource['order']
  end
end
