# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newparam(:planpath) do
  include EasyType

  desc <<-DESC
  The path of the deploymentplan

  DESC
end

if puppet_version_higher_or_equal_then('4.0.0')
  #
  # Older puppet versions don't support autosubscribe.
  # Because we want to be compatible with puppet 3, we will Skip
  # this functionality on older versions.
  #
  autosubscribe(:file) do
    self[:planpath] if self[:ensure].to_s == 'present'
  end
end
