# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:setarchiveconfigurationcount, :parent => Puppet::Parameter::WlsProperty) do
  include EasyType::Types::Integer

  extend  Puppet_X::EnterpriseModules::WebLogic::DomainPaths # Changes the actual path for domain resource

  desc <<-DESC
    The amount of archived backups of the domain configuration file retained.

  DESC

  data_type("Optional[Variant[Enum['absent'],Integer]]")

  maps_to('ArchiveConfigurationCount')
end
