# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:partition_work_manager_ref, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  A reference to a partition-level work manager policy set by the system administrator.

  An example on how to use this:

      wls_domain_partition {a_wls_domain_partition :
         ...
         partition_work_manager_ref => 'a_value'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_domain_partition:partition_work_manager_ref']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  data_type('Optional[String]')

  maps_to('PartitionWorkManagerRef')
end
