# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:rcm_historical_data_buffer_limit, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  The maximum number of elements retained for monitoring RCM usage requests over time.

  An example on how to use this:

      wls_domain_partition {a_wls_domain_partition :
         ...
         rcm_historical_data_buffer_limit => '250'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_domain_partition:rcm_historical_data_buffer_limit']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  data_type("Optional[Variant[Enum['absent'],Integer]]")

  maps_to('RCMHistoricalDataBufferLimit')
end
