# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:virtual_target, :array_matching => :all, :parent => Puppet::Parameter::WlsProperty) do
  include EasyType::ArrayProperty

  desc <<-DESC
  The virtual target for the domain partition

  An example on how to use this:

      wls_domain_partition {a_wls_domain_partition :
         ...
         virtual_target => ['target_1','target_2']
         ...
      }

  DESC

  data_type('Optional[Variant[String,Array[String]]]')

  maps_to('AvailableTargets/')

  on_apply do
    apply_paths_with_references('/VirtualTargets', value)
  end
end
