# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newparam(:logoutput) do
  include EasyType
  desc <<-DESC
  Whether to log command output in addition to logging the
  exit code.  Defaults to `on_failure`, which only logs the output
  when the command has an exit code that does not match any value
  specified by the `returns` attribute. As with any resource type,
  the log level can be controlled with the `loglevel` metaparameter."
  DESC

  defaultto :on_failure
  # rubocop:disable Lint/BooleanSymbol
  newvalues(:true, :false, :on_failure)
  # rubocop:enable Lint/BooleanSymbol
  data_type("Optional[Variant[Enum['on_failure'],Boolean]]")
end
