# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:password, :parent => Puppet::Parameter::WlsEncryptedProperty) do
  desc <<-DESC
    The bridge password.

    Usage :

        wls_jms_bridge_destination { ....:
          ...
          password => 'clear_text_password',
          ...
        }

    The password string is passed to WebLogic for encryption and then stored in the domain.

  DESC

  data_type('Optional[String]')

  maps_to('UserPassword')
end
