# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:multicast_port, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  The IP port that this topic uses to transmit messages to multicast consumers.   <!-- Gets the "port" element -->

  An example on how to use this:

      wls_jms_topic {a_wls_jms_topic :
         ...
         multicast_port => '6001'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_jms_topic:multicast_port']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC
  include EasyType::Types::Integer
  data_type("Optional[Variant[Enum['absent'],Integer[0,9999]]]")

  maps_to('Multicast/%<topic_name>s/MulticastPort')
end
