# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:bytes_paging_enabled, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  This parameter has been deprecated. Paging is always enabled. The "MessageBufferSize" parameter controls how much memory is used before paging kicks in.

  An example on how to use this:

      wls_jmsserver {a_wls_jmsserver :
         ...
         bytes_paging_enabled => 1,
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_jmsserver:bytes_paging_enabled']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  include Puppet_X::EnterpriseModules::WebLogic::Types::NumberedBoolean
  data_type("Optional[Variant[Enum['absent'],Integer[0,1]]]")

  maps_to('BytesPagingEnabled')
end
