# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:log_date_format_pattern, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  The date format pattern used for rendering dates in the  log. The DateFormatPattern string conforms to the specification of the <code>java.text.SimpleDateFormat</code> class.

  An example on how to use this:

      wls_jmsserver {a_wls_jmsserver :
         ...
         log_date_format_pattern => 'a_value'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_jmsserver:log_date_format_pattern']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  data_type('Optional[String]')

  maps_to('JMSMessageLogFile/%<jmsserver_name>s/DateFormatPattern')
end
