# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:preservemsgproperty, :parent => Puppet::Parameter::WlsProperty) do
  include Puppet_X::EnterpriseModules::WebLogic::Types::NumberedBoolean

  desc <<-DESC
  Specifies if message properties are preserved when messages are forwarded by a bridge instance.

  DESC

  data_type("Optional[Variant[Enum['absent'],Integer[0,1]]]")
  defaultto '0'

  maps_to('PreserveMsgProperty')
end
