# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:qos, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  The QOS (quality of service) for this messaging bridge instance.

  DESC

  newvalues('absent', 'Exactly-once', 'Atmost-once', 'Duplicate-okay')
  defaultto 'Exactly-once'

  maps_to('QualityOfService')

  data_type("Optional[Enum['absent', 'Exactly-once', 'Atmost-once', 'Duplicate-okay']]")
end
