# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:saf_error_handling, :parent => Puppet::Parameter::WlsProperty) do
  extend SAFImportedDestinationObjectProperty

  desc <<-DESC
  Specifies the error handling configuration used by this SAF destination.  Any change to this parameter affects only incoming messages; stored messages are not affected.

  An example on how to use this:

      wls_saf_imported_destination_object {a_wls_saf_imported_destination_object :
         ...
         saf_error_handling => 'a_value'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_saf_imported_destination_object:saf_error_handling']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  maps_to('SAFErrorHandling')
end
