# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:object_type) do
  include EasyType

  desc <<-DESC
  The object_type of the SAF imported destination object

  DESC

  munge(&:to_sym)

  newvalues('queue', 'topic')

  to_translate_to_resource do |raw_resource|
    raw_resource[:object_type]
  end

  on_modify do
    fail 'object_type is not changeable.'
  end

  data_type("Optional[Enum['queue', 'topic']]")
end
