# frozen_string_literal: true

newproperty(:rdbms_security_store, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  Returns RDBMSSecurityStoreMBean for this realm, which is a singleton MBean describing RDBMS security store configuration.

  An example on how to use this:

      wls_security_realm {a_wls_security_realm :
         ...
         rdbms_security_store => 'a_value'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_security_realm:rdbms_security_store']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  maps_to('RDBMSSecurityStore')
end
