# frozen_string_literal: true

newproperty(:fully_delegate_authorization, :parent => Puppet::Parameter::WlsProperty) do
  include Puppet_X::EnterpriseModules::WebLogic::Types::NumberedBoolean

  desc <<-DESC
  Returns whether the Web and EJB containers should call the security framework on every access.  If false the containers are free to only call the security framework when security is set in the deployment descriptors.

  An example on how to use this:

      wls_security_realm {a_wls_security_realm :
         ...
         fully_delegate_authorization => 1,
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  data_type("Optional[Variant[Enum['absent'],Integer[0,1]]]")

  maps_to('FullyDelegateAuthorization')
end
