# frozen_string_literal: true

newproperty(:management_identity_domain, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  Sets the Management Identity Domain value for the realm.

  An example on how to use this:

      wls_security_realm {a_wls_security_realm :
         ...
         management_identity_domain => 'a_value'
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  maps_to('ManagementIdentityDomain')
end
