# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:custom_identity_alias, :parent => Puppet::Parameter::WlsProperty) do
  include EasyType

  desc <<-DESC
    The custom identity alias.
  DESC

  maps_to('SSL/%<server_name>s/ServerPrivateKeyAlias')

  on_apply do
    if resource[:custom_identity].to_s == '1'
      apply_paths(value)
    else
      Puppet.warning "property #{name} ignored because custom_identity is set to 0."
    end
  end
end
