# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:verbose_ejb_deployment_enabled, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  Whether or not verbose deployment of EJBs is enabled.

  An example on how to use this:

      wls_server {a_wls_server :
         ...
         verbose_ejb_deployment_enabled => 'false'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_server:verbose_ejb_deployment_enabled']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  maps_to('VerboseEJBDeploymentEnabled')
end
