# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:webserver_url_resource, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  Adds a URL connection factory resource into JNDI.

  An example on how to use this:

      wls_server {a_wls_server :
         ...
         webserver_url_resource => 'a_value'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_server:webserver_url_resource']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  maps_to('WebServer/%<server_name>s/URLResource')
end
