# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:systempasswordencrypted, :parent => Puppet::Parameter::WlsEncryptedProperty) do
  desc <<-DESC
  The password required to access administrative functions on this server.  To set this attribute,  use <code>weblogic.management.EncryptionHelper.encrypt()</code> to encrypt the value. Then set this attribute to the output of the encrypt() method.  To compare a password that a user enters with the encrypted value of this attribute, go to the same WebLogic Server instance that you used to set and encrypt this attribute and use <code>weblogic.management.EncryptionHelper.encrypt()</code> to encrypt the user-supplied password. Then compare the encrypted values.

  An example on how to use this:

      ...{...:
         ...
         systempasswordencrypted => None
         ...
      }

  Help text generated from MBEan text.

  DESC

  maps_to('SystemPasswordEncrypted')
end
