# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:listen_port, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  The default TCP port this network channel uses to listen for regular (non-SSL) incoming connections. A value of <tt>-1</tt> indicates that the network channel should obtain this value from the server's configuration.

  An example on how to use this:

      wls_server_channel {a_wls_server_channel :
         ...
         listen_port => 'a_value'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_server_channel:listen_port']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  maps_to('ListenPort')
end
