# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:coherence_cluster_system_resource, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  The system-level Coherence cluster resource associated with this server.

  An example on how to use this:

      wls_server_template {a_wls_server_template :
         ...
         coherence_cluster_system_resource => 'a_value'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_server_template:coherence_cluster_system_resource']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  maps_to('CoherenceClusterSystemResource')
end
