# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:connect_timeout, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  The amount of time that this server should wait to establish an outbound socket connection before timing out. A value of <code>0</code> disables server connect timeout.

  An example on how to use this:

      wls_server_template {a_wls_server_template :
         ...
         connect_timeout => 'a_value'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_server_template:connect_timeout']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  maps_to('ConnectTimeout')
end
