# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:jta_migratable_target, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  Returns the JTAMigratableTargetMBean that is used to deploy the JTA Recovery Service to (is the server's cluster is not null).

  An example on how to use this:

      wls_server_template {a_wls_server_template :
         ...
         jta_migratable_target => 'a_value'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_server_template:jta_migratable_target']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  maps_to('JTAMigratableTarget')
end
