# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:listen_delay_secs, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  Perpetuated for compatibility with 6.1 only.

  An example on how to use this:

      wls_server_template {a_wls_server_template :
         ...
         listen_delay_secs => 'a_value'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_server_template:listen_delay_secs']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  maps_to('ListenDelaySecs')
end
