# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:listen_thread_start_delay_secs, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  Returns the maximum time that the server will wait for server sockets to bind before starting a listen thread.  Properties to consider for removal

  An example on how to use this:

      wls_server_template {a_wls_server_template :
         ...
         listen_thread_start_delay_secs => '60'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_server_template:listen_thread_start_delay_secs']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  maps_to('ListenThreadStartDelaySecs')
end
