# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:virtual_machine_name, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  When WLS is running on JRVE, this specifies the name of the virtual machine running this server

  An example on how to use this:

      wls_server_template {a_wls_server_template :
         ...
         virtual_machine_name => 'a_value'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_server_template:virtual_machine_name']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  maps_to('VirtualMachineName')
end
