# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:charsets, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  Provides user defined mapping between internet and Java charset names.

  An example on how to use this:

      wls_virtual_host {a_wls_virtual_host :
         ...
         charsets => 'a_value'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_virtual_host:charsets']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  maps_to('Charsets')
end
