# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:log_elf_fields, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  Returns the list of fields specified for the <code>extended</code> logging format for access.log.#{'  '}

  An example on how to use this:

      wls_virtual_host {a_wls_virtual_host :
         ...
         log_elf_fields => 'date time cs-method cs-uri sc-status'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_virtual_host:log_elf_fields']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  maps_to('WebServerLog/%<virtual_host_name>s/ELFFields')
end
