# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:http_tags, :parent => Puppet::Parameter::WlsProperty) do
  desc <<-DESC
  Return all tags on this Configuration MBean

  An example on how to use this:

      wls_virtual_target {a_wls_virtual_target :
         ...
         http_tags => 'a_value'
         ...
      }

  This is an extended property. Before you can use it add it to the `wls_settings` property `extra_properties`.

      wls_setting{'domain':
         ...
        extra_properties => ['wls_virtual_target:http_tags']
         ...
      }

  This help text generated from MBean text of the WebLogic server.

  DESC

  maps_to('WebServer/%<virtual_target_name>s/Tags')
end
